/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of Bear.xs. Do not edit this file, edit Bear.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "lib/Crypt/Bear.xs"
#include <bearssl.h>

#define PERL_NO_GET_CONTEXT
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

/* Generic stuff */

typedef struct {
	const char* key;
	size_t length;
	union value {
		const void* pointer;
		UV integer;
	} value;
} entry;
typedef entry map[];

#define make_map_int_entry(name, result) { STR_WITH_LEN(name), (union value) { .integer = result } }
#define make_map_pointer_entry(name, result) { STR_WITH_LEN(name), (union value) { .pointer = result } }

static const entry* S_map_find(pTHX_ const map table, size_t table_size, const char* name, size_t name_length) {
	size_t i;
	for (i = 0; i < table_size; ++i) {
		if (table[i].length == name_length && strEQ(name, table[i].key))
			return &table[i];
	}
	return NULL;
}
#define map_find(table, table_size, name, name_len) S_map_find(aTHX_ table, table_size, name, name_len)

static union value S_map_get(pTHX_ const map table, size_t table_size, SV* input, const char* type) {
	STRLEN name_length;
	const char* name = SvPVutf8(input, name_length);
	const entry* item = map_find(table, table_size, name, name_length);
	if (item == NULL)
		Perl_croak(aTHX_ "No such %s '%s'", type, name);
	return item->value;
}
#define map_get(table, name, type) S_map_get(aTHX_ table, sizeof table / sizeof *table, name, type)

static const entry* S_map_reverse_find(pTHX_ const map table, size_t table_size, union value value) {
	size_t i;
	for (i = 0; i < table_size; ++i) {
		if (memcmp(&table[i].value, &value, sizeof(union value)) == 0)
			return table + i;
	}
	return NULL;
}
#define map_reverse_find(table, value) S_map_reverse_find(aTHX_ table, sizeof table / sizeof *table, value)

SV* S_make_buffer(pTHX_ size_t size) {
	SV* result = newSVpv("", 0);
	SvGROW(result, size);
	SvCUR_set(result, size);
	return result;
}
#define make_buffer(size) S_make_buffer(aTHX_ size)

SV* S_make_magic(pTHX_ const void* object, const char* classname, const MGVTBL* virtual) {
	SV* result = newSV(0);
	MAGIC* magic = sv_magicext(newSVrv(result, classname), NULL, PERL_MAGIC_ext, virtual, (const char*)object, 0);
	magic->mg_flags |= MGf_COPY|MGf_DUP;
	return result;
}
#define make_magic(object, class, virtual) S_make_magic(aTHX_ object, class, virtual)

#define saveupvn(ptr, len) (unsigned char*)savepvn((const char*)ptr, len)
#define push_isa(child, parent) av_push(get_av(#child "::ISA", GV_ADD), newSVpvs(#parent))

#define br_error_entry(name, key) make_map_int_entry(name, BR_ERR_ ## key)
static const map br_errors = {
	// SSL errors

	br_error_entry("ok", OK),
	br_error_entry("bad param", BAD_PARAM),
	br_error_entry("bad state", BAD_STATE),
	br_error_entry("unsupported version", UNSUPPORTED_VERSION),
	br_error_entry("bad version", BAD_VERSION),
	br_error_entry("bad length", BAD_LENGTH),
	br_error_entry("too large", TOO_LARGE),
	br_error_entry("bad mac", BAD_MAC),
	br_error_entry("no random", NO_RANDOM),
	br_error_entry("unknown type", UNKNOWN_TYPE),
	br_error_entry("unexpected", UNEXPECTED),
	br_error_entry("bad ccs", BAD_CCS),
	br_error_entry("bad alert", BAD_ALERT),
	br_error_entry("bad handshake", BAD_HANDSHAKE),
	br_error_entry("oversized id", OVERSIZED_ID),
	br_error_entry("bad cipher suite", BAD_CIPHER_SUITE),
	br_error_entry("bad compression", BAD_COMPRESSION),
	br_error_entry("bad fraglen", BAD_FRAGLEN),
	br_error_entry("bad secreneg", BAD_SECRENEG),
	br_error_entry("extra extension", EXTRA_EXTENSION),
	br_error_entry("bad sni", BAD_SNI),
	br_error_entry("bad hello done", BAD_HELLO_DONE),
	br_error_entry("limit exceeded", LIMIT_EXCEEDED),
	br_error_entry("bad finished", BAD_FINISHED),
	br_error_entry("resume mismatch", RESUME_MISMATCH),
	br_error_entry("invalid algorithm", INVALID_ALGORITHM),
	br_error_entry("bad signature", BAD_SIGNATURE),
	br_error_entry("wrong key usage", WRONG_KEY_USAGE),
	br_error_entry("no client auth", NO_CLIENT_AUTH),
	br_error_entry("io", IO),
	br_error_entry("recv fatal alert", RECV_FATAL_ALERT),
	br_error_entry("send fatal alert", SEND_FATAL_ALERT),

	// X509 errors
	br_error_entry("ok", X509_OK),
	br_error_entry("invalid value", X509_INVALID_VALUE),
	br_error_entry("truncated", X509_TRUNCATED),
	br_error_entry("empty chain", X509_EMPTY_CHAIN),
	br_error_entry("inner trunc", X509_INNER_TRUNC),
	br_error_entry("bad tag class", X509_BAD_TAG_CLASS),
	br_error_entry("bad tag value", X509_BAD_TAG_VALUE),
	br_error_entry("indefinite length", X509_INDEFINITE_LENGTH),
	br_error_entry("extra element", X509_EXTRA_ELEMENT),
	br_error_entry("unexpected", X509_UNEXPECTED),
	br_error_entry("not constructed", X509_NOT_CONSTRUCTED),
	br_error_entry("not primitive", X509_NOT_PRIMITIVE),
	br_error_entry("partial byte", X509_PARTIAL_BYTE),
	br_error_entry("bad boolean", X509_BAD_BOOLEAN),
	br_error_entry("overflow", X509_OVERFLOW),
	br_error_entry("bad dn", X509_BAD_DN),
	br_error_entry("bad time", X509_BAD_TIME),
	br_error_entry("unsupported", X509_UNSUPPORTED),
	br_error_entry("limit exceeded", X509_LIMIT_EXCEEDED),
	br_error_entry("wrong key type", X509_WRONG_KEY_TYPE),
	br_error_entry("bad signature", X509_BAD_SIGNATURE),
	br_error_entry("time unknown", X509_TIME_UNKNOWN),
	br_error_entry("expired", X509_EXPIRED),
	br_error_entry("dn mismatch", X509_DN_MISMATCH),
	br_error_entry("bad server name", X509_BAD_SERVER_NAME),
	br_error_entry("critical extension", X509_CRITICAL_EXTENSION),
	br_error_entry("not ca", X509_NOT_CA),
	br_error_entry("forbidden key usage", X509_FORBIDDEN_KEY_USAGE),
	br_error_entry("weak public key", X509_WEAK_PUBLIC_KEY),
	br_error_entry("not trusted", X509_NOT_TRUSTED),

};
typedef unsigned br_error_type;

static const char* S_lookup_error(pTHX_ int error) {
	union value value = { .integer = error };
	const entry* entry = map_reverse_find(br_errors, value);
	return entry ? entry->key : NULL;
}
#define lookup_error(error) S_lookup_error(aTHX_ error)


/* Hash stuff */

#define hash_entry_for(name) make_map_pointer_entry(#name, (&br_ ## name ## _vtable))

static const map hashs = {
	hash_entry_for(sha256),
	hash_entry_for(sha512),
	hash_entry_for(sha384),
	hash_entry_for(sha224),
	hash_entry_for(sha1),
	hash_entry_for(md5)
};
typedef const br_hash_class* hash_type;

typedef const struct hash_oid {
	size_t length;
	unsigned char oid[10];
} *hash_oid_type;
static const struct hash_oid sha1_oid   = { 20, { 0x05, 0x2B, 0x0E, 0x03, 0x02, 0x1A } };
static const struct hash_oid sha224_oid = { 28, { 0x09, 0x60, 0x86, 0x48, 0x01, 0x65, 0x03, 0x04, 0x02, 0x04 } };
static const struct hash_oid sha256_oid = { 32, { 0x09, 0x60, 0x86, 0x48, 0x01, 0x65, 0x03, 0x04, 0x02, 0x01 } };
static const struct hash_oid sha384_oid = { 48, { 0x09, 0x60, 0x86, 0x48, 0x01, 0x65, 0x03, 0x04, 0x02, 0x02 } };
static const struct hash_oid sha512_oid = { 48, { 0x09, 0x60, 0x86, 0x48, 0x01, 0x65, 0x03, 0x04, 0x02, 0x03 } };

#define hash_oid_entry(name) make_map_pointer_entry(#name, &name ## _oid)
static const map hash_oids = {
	hash_oid_entry(sha1),
	hash_oid_entry(sha224),
	hash_oid_entry(sha256),
	hash_oid_entry(sha384),
	hash_oid_entry(sha512),
};

#define br_hash_update(hasher, data, length) (hasher->vtable->update)(&hasher->vtable, data, length)

#define br_hash_desc(hasher, field) (((hasher)->vtable->desc >> BR_HASHDESC_ ## field ## _OFF) & BR_HASHDESC_ ## field ##_MASK)
#define br_hash_output_size(hasher) br_hash_desc(hasher, OUT)
#define br_hash_state_size(hasher) br_hash_desc(hasher, STATE)
#define br_hash_digest(hasher) ((self)->vtable)
static br_ghash ghash_impl;
#define br_hmac_key_digest br_hmac_key_get_digest
#define br_hmac_digest br_hmac_get_digest

typedef br_hash_compat_context* Crypt__Bear__Hash;
typedef br_hmac_key_context* Crypt__Bear__HMAC__Key;
typedef br_hmac_context* Crypt__Bear__HMAC;


/* KDF stuff */

typedef br_hkdf_context* Crypt__Bear__HKDF;
// typedef br_shake_context* Crypt__Bear__Shake;

/* Block stuff */

static const br_block_cbcenc_class* aes_cbc_enc;
static const br_block_cbcdec_class* aes_cbc_dec;
static const br_block_ctr_class* aes_ctr;
static const br_block_ctrcbc_class* aes_ctrcbc;

#define br_block_cbcenc_block_size(cbcenc) (*cbcenc)->block_size
#define br_block_cbcdec_block_size(cbcdec) (*cbcdec)->block_size
#define br_block_ctr_block_size(ctr) (*ctr)->block_size

typedef const br_block_cbcenc_class** Crypt__Bear__CBC__Enc;
typedef const br_block_cbcdec_class** Crypt__Bear__CBC__Dec;
typedef const br_block_ctr_class** Crypt__Bear__CTR;
typedef const br_block_ctrcbc_class** Crypt__Bear__CTRCBC;

typedef br_aes_gen_cbcenc_keys* Crypt__Bear__AES_CBC__Enc;
typedef br_aes_gen_cbcdec_keys* Crypt__Bear__AES_CBC__Dec;
typedef br_aes_gen_ctr_keys* Crypt__Bear__AES_CTR;
typedef br_aes_gen_ctrcbc_keys* Crypt__Bear__AES_CTRCBC;


/* AEAD stuff */

#define br_aead_reset(self, iv, ivlen) ((*(self))->reset)(self, iv, ivlen)
#define br_aead_aad_inject(self, ad, adlen) ((*(self))->aad_inject)(self, ad, adlen)
#define br_aead_flip(self) ((*(self))->flip)(self)
#define br_aead_run(self, encrypt, out, outlen) ((*(self))->run)(self, encrypt, out, outlen)
#define br_aead_get_tag(self, buffer) ((*(self))->get_tag)(self, buffer)
#define br_aead_check_tag(self, buffer) ((*(self))->check_tag)(self, buffer)

typedef const br_aead_class** Crypt__Bear__AEAD;
typedef br_gcm_context* Crypt__Bear__GCM;
typedef br_eax_context* Crypt__Bear__EAX;
typedef br_ccm_context* Crypt__Bear__CCM;


/* PRNG stuff */

static br_prng_seeder system_seeder;
static const char* system_seeder_name;
#define br_prng_system_seeder_name(class) system_seeder_name
#define br_prng_update(prng, data, length) ((*prng)->update)(prng, data, length)
#define br_hmac_drbg_digest br_hmac_drbg_get_hash

typedef const br_prng_class** Crypt__Bear__PRNG;
typedef br_hmac_drbg_context* Crypt__Bear__HMAC__DRBG;
typedef br_aesctr_drbg_context* Crypt__Bear__AES_CTR__DRBG;


/* RSA stuff */

static br_rsa_pkcs1_vrfy rsa_pkcs1_verify;
static br_rsa_pkcs1_sign rsa_pkcs1_sign;
static br_rsa_oaep_encrypt rsa_oaep_encrypt;
static br_rsa_oaep_decrypt rsa_oaep_decrypt;
static br_rsa_keygen rsa_keygen;

static void S_rsa_key_copy(pTHX_ br_rsa_public_key* dest, const br_rsa_public_key* source) {
	char* buffer = safemalloc(source->nlen + source->elen);
	dest->n = memcpy(buffer, source->n, source->nlen);
	dest->nlen = source->nlen;
	buffer += source->nlen;
	dest->e = memcpy(buffer, source->e, source->elen);
	dest->elen = source->elen;
}
#define rsa_key_copy(dest, source) S_rsa_key_copy(aTHX_ dest, source)

#define rsa_key_destroy(target) Safefree((target)->n)

static int rsa_key_dup(pTHX_ MAGIC* magic, CLONE_PARAMS* params) {
	br_rsa_public_key* old = (br_rsa_public_key*)magic->mg_ptr;
	br_rsa_public_key* self = safemalloc(sizeof(br_rsa_public_key));
	rsa_key_copy(self, old);
	magic->mg_ptr = (char*)self;
	return 0;
}

static int rsa_key_free(pTHX_ SV* sv, MAGIC* magic) {
	br_rsa_public_key* self = (br_rsa_public_key*)magic->mg_ptr;
	rsa_key_destroy(self);
	Safefree(self);
	return 0;
}

static const MGVTBL Crypt__Bear__RSA__PublicKey_magic = {
	.svt_dup = rsa_key_dup,
	.svt_free = rsa_key_free,
};

typedef br_rsa_public_key* Crypt__Bear__RSA__PublicKey;

static void S_rsa_private_key_copy(pTHX_ br_rsa_private_key* dest, const br_rsa_private_key* source) {
	char* buffer = safemalloc(source->plen + source->qlen + source->dplen + source->dqlen + source->iqlen);
	dest->n_bitlen = source->n_bitlen;
	dest->p = memcpy(buffer, source->p, source->plen);
	dest->plen = source->plen;
	buffer += source->plen;
	dest->q = memcpy(buffer, source->q, source->qlen);
	dest->qlen = source->qlen;
	buffer += source->qlen;
	dest->dp = memcpy(buffer, source->dp, source->dplen);
	dest->dplen = source->dplen;
	buffer += source->dplen;
	dest->dq = memcpy(buffer, source->dq, source->dqlen);
	dest->dqlen = source->dqlen;
	buffer += source->dqlen;
	dest->iq = memcpy(buffer, source->iq, source->iqlen);
	dest->iqlen = source->iqlen;
	buffer += source->iqlen;
}
#define rsa_private_key_copy(dest, source) S_rsa_private_key_copy(aTHX_ dest, source)
#define rsa_private_key_destroy(target) Safefree((target)->p)

static int rsa_private_key_dup(pTHX_ MAGIC* magic, CLONE_PARAMS* params) {
	br_rsa_private_key* old = (br_rsa_private_key*)magic->mg_ptr;
	br_rsa_private_key* self = safemalloc(sizeof(br_rsa_private_key));
	rsa_private_key_copy(self, old);
	magic->mg_ptr = (char*)self;
	return 0;
}

static int rsa_private_key_free(pTHX_ SV* sv, MAGIC* magic) {
	br_rsa_private_key* self = (br_rsa_private_key*)magic->mg_ptr;
	rsa_private_key_destroy(self);
	Safefree(self);
	return 0;
}

static const MGVTBL Crypt__Bear__RSA__PrivateKey_magic = {
	.svt_dup = rsa_private_key_dup,
	.svt_free = rsa_private_key_free,
};

typedef br_rsa_private_key* Crypt__Bear__RSA__PrivateKey;


/* EC stuff */

static const size_t ecdsa_max_size = 132;

typedef U32 curve_type;
#define curve_entry_for(name) make_map_int_entry(#name, BR_EC_ ## name)

static const map curves = {
	curve_entry_for(sect163k1),
	curve_entry_for(sect163r1),
	curve_entry_for(sect163r2),
	curve_entry_for(sect193r1),
	curve_entry_for(sect193r2),
	curve_entry_for(sect233k1),
	curve_entry_for(sect233r1),
	curve_entry_for(sect239k1),
	curve_entry_for(sect283k1),
	curve_entry_for(sect283r1),
	curve_entry_for(sect409k1),
	curve_entry_for(sect409r1),
	curve_entry_for(sect571k1),
	curve_entry_for(sect571r1),

	curve_entry_for(secp160k1),
	curve_entry_for(secp160r1),
	curve_entry_for(secp160r2),
	curve_entry_for(secp192k1),
	curve_entry_for(secp192r1),
	curve_entry_for(secp224k1),
	curve_entry_for(secp224r1),
	curve_entry_for(secp256k1),
	curve_entry_for(secp256r1),
	curve_entry_for(secp384r1),
	curve_entry_for(secp521r1),

	curve_entry_for(brainpoolP256r1),
	curve_entry_for(brainpoolP384r1),
	curve_entry_for(brainpoolP512r1),

	curve_entry_for(curve25519),
	curve_entry_for(curve448),
};

static void S_ec_key_copy(pTHX_ br_ec_public_key* dest, const br_ec_public_key* source) {
	dest->curve = source->curve;
	dest->q = saveupvn(source->q, source->qlen);
	dest->qlen = source->qlen;
}
#define ec_key_copy(dest, source) S_ec_key_copy(aTHX_ dest, source)

#define ec_key_destroy(key) Safefree((key)->q)

static int ec_key_dup(pTHX_ MAGIC* magic, CLONE_PARAMS* params) {
	br_ec_public_key* old = (br_ec_public_key*)magic->mg_ptr;
	br_ec_public_key* self = safemalloc(sizeof(br_ec_public_key));
	ec_key_copy(self, old);
	magic->mg_ptr = (char*)self;
	return 0;
}

static int ec_key_free(pTHX_ SV* sv, MAGIC* magic) {
	br_ec_public_key* self = (br_ec_public_key*)magic->mg_ptr;
	ec_key_destroy(self);
	Safefree(self);
	return 0;
}

static const MGVTBL Crypt__Bear__EC__PublicKey_magic = {
	.svt_dup = ec_key_dup,
	.svt_free = ec_key_free,
};

static void S_ec_private_key_copy(pTHX_ br_ec_private_key* dest, const br_ec_private_key* source) {
	dest->curve = source->curve;
	dest->x = saveupvn(source->x, source->xlen);
	dest->xlen = source->xlen;
}
#define ec_private_key_copy(dest, source) S_ec_private_key_copy(aTHX_ dest, source)
#define ec_private_key_destroy(target) Safefree((target)->x)

static int ec_privatekey_dup(pTHX_ MAGIC* magic, CLONE_PARAMS* params) {
	br_ec_private_key* old = (br_ec_private_key*)magic->mg_ptr;
	br_ec_private_key* self = safemalloc(sizeof(br_ec_private_key));
	ec_private_key_copy(self, old);
	magic->mg_ptr = (char*)self;
	return 0;
}

static int ec_privatekey_free(pTHX_ SV* sv, MAGIC* magic) {
	br_ec_private_key* self = (br_ec_private_key*)magic->mg_ptr;
	ec_private_key_destroy(self);
	Safefree(self);
	return 0;
}

static const MGVTBL Crypt__Bear__EC__PrivateKey_magic = {
	.svt_dup = ec_privatekey_dup,
	.svt_free = ec_privatekey_free,
};

static const br_ec_impl* ec_default;
static const br_ec_impl* ec_c25519;
static br_ecdsa_sign ec_sign_default;
static br_ecdsa_vrfy ec_verify_default;

typedef br_ec_public_key* Crypt__Bear__EC__PublicKey;
typedef br_ec_private_key* Crypt__Bear__EC__PrivateKey;
typedef const br_ec_impl* Crypt__Bear__EC;


/* PEM stuff */

#define pem_flag_entry_for(name, value) make_map_int_entry(name, BR_PEM_ ## value)
static const map pem_flags = {
	pem_flag_entry_for("line64", LINE64),
	pem_flag_entry_for("crlf", CRLF),
};
#define lookup_pem_flag(name) (map_get(pem_flags, name, "pem flag").integer)

typedef struct {
#ifdef MULTIPLICITY
	tTHX aTHX;
#endif
	br_pem_decoder_context decoder;
	SV* callback;
	SV* name;
	SV* buffer;
} pem_decoder;

static void pem_callback(void* ptr, const void* data, size_t length) {
	pem_decoder* current = ptr;
	dTHXa(current->aTHX);
	sv_catpvn(current->buffer, data, length);
}

static int pem_decoder_dup(pTHX_ MAGIC* magic, CLONE_PARAMS* params) {
	pem_decoder* decoder = (pem_decoder*)magic->mg_ptr;
	pem_decoder* self = safecalloc(1, sizeof(pem_decoder));

#ifdef MULTIPLICITY
	self->aTHX = aTHX;
	self->callback = sv_dup_inc(decoder->callback, params);
	if (decoder->buffer)
		self->buffer = sv_dup_inc(decoder->buffer, params);
	if (decoder->name)
		self->name = sv_dup_inc(decoder->name, params);
	if (decoder->decoder.dest_ctx)
		self->decoder.dest_ctx = self;
#endif

	return 0;
}

static int pem_decoder_free(pTHX_ SV* sv, MAGIC* magic) {
	pem_decoder* decoder = (pem_decoder*)magic->mg_ptr;

	SvREFCNT_dec(decoder->callback);
	if (decoder->buffer)
		SvREFCNT_dec(decoder->buffer);
	if (decoder->name)
		SvREFCNT_dec(decoder->name);

	Safefree(decoder);

	return 0;
}

static const MGVTBL Crypt__Bear__PEM__Decoder_magic = {
	.svt_dup = pem_decoder_dup,
	.svt_free = pem_decoder_free,
};

typedef pem_decoder* Crypt__Bear__PEM__Decoder;


/* X509 stuff */

#define usage_entry_for(name, value) make_map_int_entry(name, value)
static const map usages = {
	usage_entry_for("key-exchange", BR_KEYTYPE_KEYX),
	usage_entry_for("signing", BR_KEYTYPE_SIGN),
	usage_entry_for("both", BR_KEYTYPE_KEYX | BR_KEYTYPE_SIGN),
};
typedef unsigned usage_type;

static void S_dn_init(pTHX_ br_x500_name* dest, const unsigned char* data, size_t data_len) {
	dest->data = saveupvn(data, data_len);
	dest->len = data_len;
}
#define dn_init(dest, data, data_len) S_dn_init(aTHX_ dest, data, data_len)

static void S_dn_copy(pTHX_ br_x500_name* dest, const br_x500_name* source) {
	dn_init(dest, source->data, source->len);
}
#define dn_copy(dest, source) S_dn_copy(aTHX_ dest, source)

#define dn_to_sv(dn) newSVpvn((const char*)(dn).data, (dn).len)

#define dn_destroy(target) Safefree((target)->data)

typedef struct certificate {
	br_x509_certificate cert;
	br_x509_decoder_context decoder;
	br_x500_name dn;
} *Crypt__Bear__X509__Certificate;

#define key_type_entry(name, value) make_map_int_entry(name, BR_KEYTYPE_ ## value)
static const map key_kinds = {
	key_type_entry("rsa", RSA),
	key_type_entry("ec", EC),
};
typedef unsigned key_kind_type;

struct decoder_helper {
#ifdef MULTIPLICITY
	tTHX aTHX;
#endif
	SV* value;
};

static void dn_decoder(void *ctx, const void *buf, size_t len) {
	struct decoder_helper* current = (struct decoder_helper*) ctx;
	dTHXa(current->aTHX);
	sv_catpvn(current->value, buf, len);
}

static void S_br_x509_certificate_init(pTHX_ br_x509_certificate* dest, const unsigned char* data, size_t data_len) {
	dest->data = saveupvn(data, data_len);
	dest->data_len = data_len;
}
#define br_x509_certificate_init(cert, data, data_len) S_br_x509_certificate_init(aTHX_ cert, data, data_len)

static void S_br_x509_certificate_copy(pTHX_ br_x509_certificate* dest, const br_x509_certificate* source) {
	br_x509_certificate_init(dest, source->data, source->data_len);
}
#define br_x509_certificate_copy(dest, source) S_br_x509_certificate_copy(aTHX_ dest, source)

#define br_x509_certificate_destroy(target) Safefree((target)->data)

#define br_x509_certificate_dn(self) dn_to_sv((self)->dn)
#define br_x509_certificate_is_ca(self) br_x509_decoder_isCA(&(self)->decoder)
#define br_x509_certificate_signer_key_type(self) br_x509_decoder_get_signer_key_type(&(self)->decoder)

static void S_certificate_destroy(pTHX_ struct certificate* cert) {
	dn_destroy(&cert->dn);
	br_x509_certificate_destroy(&cert->cert);
}
#define certificate_destroy(target) S_certificate_destroy(aTHX_ target)

static void S_certificate_copy(pTHX_ struct certificate* dest, const struct certificate* source) {
	br_x509_certificate_copy(&dest->cert, &source->cert);
	memcpy(&dest->decoder, &source->decoder, sizeof(br_x509_decoder_context));
	dn_copy(&dest->dn, &source->dn);
}
#define certificate_copy(dest, source) S_certificate_copy(aTHX_ dest, source)

static int certificate_dup(pTHX_ MAGIC* magic, CLONE_PARAMS* params) {
	struct certificate* old = (struct certificate*)magic->mg_ptr;
	struct certificate* self = safemalloc(sizeof(struct certificate));
	certificate_copy(self, old);
	magic->mg_ptr = (char*)self;
	return 0;
}

static int certificate_free(pTHX_ SV* sv, MAGIC* magic) {
	struct certificate* cert = (struct certificate*)magic->mg_ptr;
	certificate_destroy(cert);
	Safefree(cert);
	return 0;
}

static const MGVTBL Crypt__Bear__X509__Certificate_magic = {
	.svt_dup = certificate_dup,
	.svt_free = certificate_free
};

static SV* S_x509_key_unpack(pTHX_ const br_x509_pkey* public_key) {
	if (public_key->key_type == BR_KEYTYPE_RSA) {
		br_rsa_public_key* key = safemalloc(sizeof *key);
		rsa_key_copy(key, &public_key->key.rsa);
		return make_magic(key, "Crypt::Bear::RSA::PublicKey", &Crypt__Bear__RSA__PublicKey_magic);
	} else if (public_key->key_type == BR_KEYTYPE_EC) {
		br_ec_public_key* key = safemalloc(sizeof *key);
		ec_key_copy(key, &public_key->key.ec);
		return make_magic(key, "Crypt::Bear::EC::PublicKey", &Crypt__Bear__EC__PublicKey_magic);
	}
	return &PL_sv_undef;
}
#define x509_key_unpack(key) S_x509_key_unpack(aTHX_ key)


static void S_x509_key_copy(pTHX_ br_x509_pkey* dest, const br_x509_pkey* source) {
	dest->key_type = source->key_type;
	if (source->key_type == BR_KEYTYPE_RSA) {
		rsa_key_copy(&dest->key.rsa, &source->key.rsa);
	} else if (source->key_type == BR_KEYTYPE_EC) {
		ec_key_copy(&dest->key.ec, &source->key.ec);
	}
}
#define x509_key_copy(dest, source) S_x509_key_copy(aTHX_ dest, source)

static void S_x509_key_destroy(pTHX_ br_x509_pkey* target) {
	if (target->key_type == BR_KEYTYPE_RSA) {
		rsa_key_destroy(&target->key.rsa);
	} else if (target->key_type == BR_KEYTYPE_EC) {
		ec_key_destroy(&target->key.ec);
	}
}
#define x509_key_destroy(dest) S_x509_key_destroy(aTHX_ dest)


static void S_trust_anchor_copy(pTHX_ br_x509_trust_anchor* dest, const br_x509_trust_anchor* source) {
	dest->flags = source->flags;
	dn_copy(&dest->dn, &source->dn);
	x509_key_copy(&dest->pkey, &source->pkey);
}
#define trust_anchor_copy(dest, source) S_trust_anchor_copy(aTHX_ dest, source)

static void S_trust_anchor_destroy(pTHX_ br_x509_trust_anchor* target) {
	Safefree(target->dn.data);
	x509_key_destroy(&target->pkey);
}
#define trust_anchor_destroy(target) S_trust_anchor_destroy(aTHX_ target)

typedef struct trust_anchors {
	br_x509_trust_anchor* array;
	size_t allocated;
	size_t used;
} *Crypt__Bear__X509__TrustAnchors;


static void trust_anchors_init(struct trust_anchors* target) {
	target->array = NULL;
	target->allocated = 0;
	target->used = 0;
}

static void S_trust_anchors_destroy(pTHX_ struct trust_anchors* target) {
	for (size_t i = 0; i < target->used; i++) {
		trust_anchor_destroy(target->array + i);
	}
	Safefree(target->array);
}
#define trust_anchors_destroy(target) S_trust_anchors_destroy(aTHX_ target)

static void S_trust_anchors_copy(pTHX_ struct trust_anchors* dest, const struct trust_anchors* source) {
	dest->used = source->used;
	dest->array = safecalloc(source->allocated, sizeof(br_x509_trust_anchor));
	dest->allocated = source->allocated;

	for (size_t i = 0; i < source->used; i++) {
		trust_anchor_copy(dest->array + i, source->array + i);
	}
}
#define trust_anchors_copy(dest, source) S_trust_anchors_copy(aTHX_ dest, source)

static void S_trust_anchors_push(pTHX_ struct trust_anchors* anchors, const br_x509_trust_anchor* anchor) {
	if (anchors->allocated == 0) {
		anchors->array = safemalloc(8 * sizeof(br_x509_trust_anchor));
		anchors->allocated = 8;
	}
	else if (anchors->used == anchors->allocated) {
		anchors->allocated = anchors->allocated ? 2 * anchors->allocated : 4;
		size_t new_size = anchors->allocated * sizeof(br_x509_trust_anchor);
		anchors->array = saferealloc(anchors->array, new_size);
	}
	memcpy(anchors->array + anchors->used, anchor, sizeof *anchor);
	anchors->used++;
}
#define trust_anchors_push(anchors, new_anchor) S_trust_anchors_push(aTHX_ anchors, new_anchor)

static int trust_anchors_dup(pTHX_ MAGIC* magic, CLONE_PARAMS* params) {
	struct trust_anchors* old = (struct trust_anchors*)magic->mg_ptr;
	struct trust_anchors* copy = safemalloc(sizeof *copy);
	trust_anchors_copy(copy, old);
	return 0;
}

static int trust_anchors_free(pTHX_ SV* sv, MAGIC* magic) {
	struct trust_anchors* trust = (struct trust_anchors*)magic->mg_ptr;
	trust_anchors_destroy(trust);
	Safefree(trust);
	return 0;
}

static const MGVTBL Crypt__Bear__X509__TrustAnchors_magic = {
	.svt_dup = trust_anchors_dup,
	.svt_free = trust_anchors_free,
};


typedef struct certificate_chain {
	br_x509_certificate* array;
	size_t allocated;
	size_t used;
	unsigned signer_key_type;
} *Crypt__Bear__X509__Certificate__Chain;


static void certificate_chain_init(struct certificate_chain* target) {
	target->array = NULL;
	target->allocated = 0;
	target->used = 0;
}

static void S_certificate_chain_push(pTHX_ struct certificate_chain* certificates, const br_x509_certificate* anchor) {
	if (certificates->used == certificates->allocated) {
		certificates->allocated = certificates->allocated ? 2 * certificates->allocated : 4;
		size_t new_size = certificates->allocated * sizeof(br_x509_certificate);
		certificates->array = saferealloc(certificates->array, new_size);
	}
	memcpy(certificates->array + certificates->used, anchor, sizeof *anchor);
	certificates->used++;
}
#define certificate_chain_push(anchors, new_anchor) S_certificate_chain_push(aTHX_ anchors, new_anchor)

static void S_certificate_chain_copy(pTHX_ struct certificate_chain* dest, const struct certificate_chain* source) {
	dest->used = source->used;
	dest->array = safecalloc(source->allocated, sizeof(br_x509_certificate));
	dest->allocated = source->allocated;

	for (size_t i = 0; i < source->used; i++) {
		br_x509_certificate_copy(dest->array + i, source->array + i);
	}
}
#define certificate_chain_copy(dest, source) S_certificate_chain_copy(aTHX_ dest, source)

static int certificate_chain_dup(pTHX_ MAGIC* magic, CLONE_PARAMS* params) {
	struct certificate_chain* old = (struct certificate_chain*)magic->mg_ptr;
	struct certificate_chain* copy = safemalloc(sizeof *copy);
	certificate_chain_copy(copy, old);
	return 0;
}

static void S_certificate_chain_destroy(pTHX_ struct certificate_chain* chain) {
	for (size_t i = 0; i < chain->used; i++) {
		br_x509_certificate_destroy(chain->array + i);
	}
	Safefree(chain->array);
}
#define certificate_chain_destroy(chain) S_certificate_chain_destroy(aTHX_ chain)

static int certificate_chain_free(pTHX_ SV* sv, MAGIC* magic) {
	struct certificate_chain* chain = (struct certificate_chain*)magic->mg_ptr;
	certificate_chain_destroy(chain);
	Safefree(chain);
	return 0;
}

static const MGVTBL Crypt__Bear__X509__Certificate__Chain_magic = {
	.svt_dup = certificate_chain_dup,
	.svt_free = certificate_chain_free,
};

typedef struct private_key {
	unsigned key_type;
	union {
		br_rsa_private_key rsa;
		br_ec_private_key ec;
	};
} *Crypt__Bear__X509__PrivateKey;

static void S_private_key_copy(pTHX_ struct private_key* copy, const struct private_key* old) {
	copy->key_type = old->key_type;
	if (old->key_type == BR_KEYTYPE_RSA)
		rsa_private_key_copy(&copy->rsa, &old->rsa);
	else
		ec_private_key_copy(&copy->ec, &old->ec);
}
#define private_key_copy(copy, old) S_private_key_copy(aTHX_ copy, old)

static int private_key_dup(pTHX_ MAGIC* magic, CLONE_PARAMS* params) {
	struct private_key* old = (struct private_key*)magic->mg_ptr;
	struct private_key* copy = safemalloc(sizeof *copy);
	private_key_copy(copy, old);
	return 0;
}

static void S_private_key_destroy(pTHX_ struct private_key* self) {
	if (self->key_type == BR_KEYTYPE_RSA)
		rsa_private_key_destroy(&self->rsa);
	else
		ec_private_key_destroy(&self->ec);
}
#define private_key_destroy(self) S_private_key_destroy(aTHX_ self)

static int private_key_free(pTHX_ SV* sv, MAGIC* magic) {
	struct private_key* self = (struct private_key*)magic->mg_ptr;
	private_key_destroy(self);
	return 0;
}

static const MGVTBL Crypt__Bear__X509__PrivateKey_magic = {
	.svt_dup = private_key_dup,
	.svt_free = private_key_free,
};

static unsigned S_private_key_usage(pTHX_ struct private_key* key) {
	if (key->key_type == BR_KEYTYPE_EC) {
		unsigned result = BR_KEYTYPE_KEYX;
		if (key->ec.curve == BR_EC_secp256r1 || key->ec.curve == BR_EC_secp384r1 || BR_EC_secp521r1)
			result |= BR_KEYTYPE_SIGN;
		return result;
	} else {
		return BR_KEYTYPE_SIGN;
	}
}
#define private_key_usage(key) S_private_key_usage(aTHX_ key)

typedef const br_x509_class** Crypt__Bear__X509__Validator;

typedef struct validator_minimal {
	br_x509_minimal_context context;
	struct trust_anchors anchors;
} *Crypt__Bear__X509__Validator__Minimal;

typedef br_x509_knownkey_context* Crypt__Bear__X509__Validator__KnownKey;

/* SSL stuff */

#define ssl_flag_entry(name, key) make_map_int_entry(name, BR_OPT_ ## key)
static const map ssl_flags = {
	ssl_flag_entry("enforce-server-preferences", ENFORCE_SERVER_PREFERENCES),
	ssl_flag_entry("no-renegotiation", NO_RENEGOTIATION),
	ssl_flag_entry("tolerate-no-client-auth", TOLERATE_NO_CLIENT_AUTH),
	ssl_flag_entry("fail-on-alpn-mismatch", FAIL_ON_ALPN_MISMATCH),
};
typedef unsigned ssl_flag_type;

#define ssl_version_entry(name, key) make_map_int_entry(name, BR_ ## key)
static const map ssl_versions = {
	ssl_version_entry("tls-1.0", TLS10),
	ssl_version_entry("tls-1.1", TLS11),
	ssl_version_entry("tls-1.2", TLS12),
};
typedef unsigned ssl_version_type;

typedef br_ssl_session_parameters* Crypt__Bear__SSL__Session;
typedef br_ssl_engine_context* Crypt__Bear__SSL__Engine;

typedef const br_ssl_client_certificate_class** Crypt__Bear__SSL__Client__Certificate;


typedef struct private_certificate {
	struct certificate_chain chain;
	struct private_key key;
	unsigned usage;
} *Crypt__Bear__SSL__PrivateCertificate;

#define private_certificate_init(self) memset(self, '\0', sizeof(struct private_certificate))

static void S_private_certificate_copy(pTHX_ struct private_certificate* dest, const struct private_certificate* source) {
	certificate_chain_copy(&dest->chain, &source->chain);
	private_key_copy(&dest->key, &source->key);
}
#define private_certificate_copy(dest, source) S_private_certificate_copy(aTHX_ dest, source)

static int private_certificate_dup(pTHX_ MAGIC* magic, CLONE_PARAMS* params) {
	struct private_certificate* old = (struct private_certificate*)magic->mg_ptr;
	struct private_certificate* copy = safemalloc(sizeof *copy);

	private_certificate_copy(copy, old);
	magic->mg_ptr = (char*)copy;

	return 0;
}

static void S_private_certificate_destroy(pTHX_ struct private_certificate* self) {
	private_key_destroy(&self->key);
	certificate_chain_destroy(&self->chain);
}
#define private_certificate_destroy(self) S_private_certificate_destroy(aTHX_ self)

static int private_certificate_free(pTHX_ SV* sv, MAGIC* magic) {
	struct private_certificate* self = (struct private_certificate*)magic->mg_ptr;
	private_certificate_destroy(self);
	Safefree(self);
	return 0;
}


static const MGVTBL Crypt__Bear__SSL__PrivateCertificate_magic = {
	.svt_dup = private_certificate_dup,
	.svt_free = private_certificate_free,
};


typedef struct ssl_client {
	br_ssl_client_context context;
	struct private_certificate private;
	unsigned char buffer[BR_SSL_BUFSIZE_BIDI];
	br_x509_minimal_context minimal;
	struct trust_anchors trust_anchors;
} *Crypt__Bear__SSL__Client;

static void ssl_engine_buffer_move(br_ssl_engine_context* new, const br_ssl_engine_context* old, unsigned char* buffer) {
	// HIC SUNT DRACONES
	new->ibuf = buffer;
	new->obuf = buffer + old->ibuf_len;
}

static int ssl_client_dup(pTHX_ MAGIC* magic, CLONE_PARAMS* params) {
	struct ssl_client* old = (struct ssl_client*)magic->mg_ptr;
	struct ssl_client* copy = safemalloc(sizeof *copy);

	private_certificate_copy(&copy->private, &old->private);
	trust_anchors_copy(&copy->trust_anchors, &old->trust_anchors);
	br_x509_minimal_init_full(&copy->minimal, copy->trust_anchors.array, copy->trust_anchors.used);
	br_ssl_engine_set_x509(&copy->context.eng, &copy->minimal.vtable);
	ssl_engine_buffer_move(&copy->context.eng, &old->context.eng, copy->buffer);

	magic->mg_ptr = (char*)copy;

	return 0;
}

static int ssl_client_free(pTHX_ SV* sv, MAGIC* magic) {
	struct ssl_client* self = (struct ssl_client*)magic->mg_ptr;

	trust_anchors_destroy(&self->trust_anchors);
	private_certificate_destroy(&self->private);

	Safefree(self);

	return 0;
}

static const MGVTBL Crypt__Bear__SSL__Client_magic = {
	.svt_dup = ssl_client_dup,
	.svt_free = ssl_client_free,
};

typedef struct ssl_server {
	br_ssl_server_context context;
	struct private_certificate private;
	unsigned char buffer[BR_SSL_BUFSIZE_BIDI];
} *Crypt__Bear__SSL__Server;


static int ssl_server_dup(pTHX_ MAGIC* magic, CLONE_PARAMS* params) {
	struct ssl_server* old = (struct ssl_server*)magic->mg_ptr;
	struct ssl_server* copy = safemalloc(sizeof *copy);

	private_certificate_copy(&copy->private, &old->private);
	ssl_engine_buffer_move(&copy->context.eng, &old->context.eng, copy->buffer);

	magic->mg_ptr = (char*)copy;

	return 0;
}

static int ssl_server_free(pTHX_ SV* sv, MAGIC* magic) {
	struct ssl_server* self = (struct ssl_server*)magic->mg_ptr;
	private_certificate_destroy(&self->private);
	Safefree(self);
	return 0;
}

static const MGVTBL Crypt__Bear__SSL__Server_magic = {
	.svt_dup = ssl_server_dup,
	.svt_free = ssl_server_free,
};


/* DIRTY STUFF */

// Make various default values pretty for XS's error messages
#define automatic private_key_usage(key)
#define undef &PL_sv_undef

// Unicode stuff. This will force byte semantics on all string
#undef SvPV
#define SvPV(sv, len) SvPVbyte(sv, len)
#undef SvPV_nolen
#define SvPV_nolen(sv) SvPVbyte_nolen(sv)


#line 1029 "lib/Crypt/Bear.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 1173 "lib/Crypt/Bear.c"

XS_EUPXS(XS_Crypt__Bear_get_config); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear_get_config)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "class");
    {
	SV *	RETVAL;
#line 1025 "lib/Crypt/Bear.xs"
	const br_config_option* current = br_get_config();
	HV* hash = newHV();
	while (current->name) {
		SV* val = newSVuv(current->value);
		hv_store(hash, current->name, strlen(current->name), val, 0);
		current++;
	}
	RETVAL = newRV_noinc((SV*)hash);
#line 1192 "lib/Crypt/Bear.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__Hash_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__Hash_new)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "class, hash");
    {
	Crypt__Bear__Hash	RETVAL;
	hash_type	hash = (map_get(hashs, ST(1), "hash").pointer)
;
#line 1041 "lib/Crypt/Bear.xs"
	RETVAL = safemalloc(hash->context_size);
	(*hash->init)(&RETVAL->vtable);
#line 1213 "lib/Crypt/Bear.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    {
		    sv_setref_pvn(RETVALSV, "Crypt::Bear::Hash", (const char*)RETVAL, sizeof(*RETVAL));
		    SvREADONLY_on(SvRV(RETVALSV));
	    }
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__Hash_update); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__Hash_update)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, data");
    {
	STRLEN	STRLEN_length_of_data;
	size_t	XSauto_length_of_data;
	Crypt__Bear__Hash	self;
	const char *	data = (const char *)SvPV(ST(1), STRLEN_length_of_data);

	XSauto_length_of_data = STRLEN_length_of_data;

    {
		SV * sv = ST(0);
		if (SvROK(sv) && sv_derived_from(sv, "Crypt::Bear::Hash"))
			self = (Crypt__Bear__Hash)SvPV_nolen(SvRV(sv));
		else
			croak("%s: %s is not of type %s", "Crypt::Bear::Hash::update", "self", "Crypt::Bear::Hash");
    }
;

	br_hash_update(self, data, XSauto_length_of_data);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__Bear__Hash_out); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__Hash_out)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	RETVAL;
	Crypt__Bear__Hash	self;

    {
		SV * sv = ST(0);
		if (SvROK(sv) && sv_derived_from(sv, "Crypt::Bear::Hash"))
			self = (Crypt__Bear__Hash)SvPV_nolen(SvRV(sv));
		else
			croak("%s: %s is not of type %s", "Crypt::Bear::Hash::out", "self", "Crypt::Bear::Hash");
    }
;
#line 1050 "lib/Crypt/Bear.xs"
	RETVAL = make_buffer(br_hash_output_size(self));
	(self->vtable->out)(&self->vtable, SvPVX(RETVAL));
#line 1278 "lib/Crypt/Bear.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__Hash_state); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__Hash_state)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	RETVAL;
	Crypt__Bear__Hash	self;

    {
		SV * sv = ST(0);
		if (SvROK(sv) && sv_derived_from(sv, "Crypt::Bear::Hash"))
			self = (Crypt__Bear__Hash)SvPV_nolen(SvRV(sv));
		else
			croak("%s: %s is not of type %s", "Crypt::Bear::Hash::state", "self", "Crypt::Bear::Hash");
    }
;
#line 1057 "lib/Crypt/Bear.xs"
	RETVAL = make_buffer(br_hash_state_size(self));
	(self->vtable->state)(&self->vtable, SvPVX(RETVAL));
#line 1307 "lib/Crypt/Bear.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__Hash_set_state); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__Hash_set_state)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, state");
    {
	STRLEN	STRLEN_length_of_state;
	size_t	XSauto_length_of_state;
	Crypt__Bear__Hash	self;
	const char *	state = (const char *)SvPV(ST(1), STRLEN_length_of_state);

	XSauto_length_of_state = STRLEN_length_of_state;

    {
		SV * sv = ST(0);
		if (SvROK(sv) && sv_derived_from(sv, "Crypt::Bear::Hash"))
			self = (Crypt__Bear__Hash)SvPV_nolen(SvRV(sv));
		else
			croak("%s: %s is not of type %s", "Crypt::Bear::Hash::set_state", "self", "Crypt::Bear::Hash");
    }
;
#line 1064 "lib/Crypt/Bear.xs"
	size_t output_size = br_hash_state_size(self);
	if (STRLEN_length_of_state != br_hash_state_size(self))
		Perl_croak(aTHX_ "State hash wrong size");
	(self->vtable->set_state)(&self->vtable, state, STRLEN_length_of_state);
#line 1342 "lib/Crypt/Bear.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__Bear__Hash_digest); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__Hash_digest)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	hash_type	RETVAL;
	Crypt__Bear__Hash	self;

    {
		SV * sv = ST(0);
		if (SvROK(sv) && sv_derived_from(sv, "Crypt::Bear::Hash"))
			self = (Crypt__Bear__Hash)SvPV_nolen(SvRV(sv));
		else
			croak("%s: %s is not of type %s", "Crypt::Bear::Hash::digest", "self", "Crypt::Bear::Hash");
    }
;

	RETVAL = br_hash_digest(self);
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    STMT_START {
		    union value value = { .pointer = RETVAL };
		    const entry* entry = map_reverse_find(hashs, value);
		    RETVALSV = entry ? newSVpvn(entry->key, entry->length) : newSV(0);
	    } STMT_END;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__Hash_output_size); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__Hash_output_size)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	UV	RETVAL;
	dXSTARG;
	Crypt__Bear__Hash	self;

    {
		SV * sv = ST(0);
		if (SvROK(sv) && sv_derived_from(sv, "Crypt::Bear::Hash"))
			self = (Crypt__Bear__Hash)SvPV_nolen(SvRV(sv));
		else
			croak("%s: %s is not of type %s", "Crypt::Bear::Hash::output_size", "self", "Crypt::Bear::Hash");
    }
;

	RETVAL = br_hash_output_size(self);
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__HMAC__Key_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__HMAC__Key_new)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "class, hash, key");
    {
	Crypt__Bear__HMAC__Key	RETVAL;
	STRLEN	STRLEN_length_of_key;
	size_t	XSauto_length_of_key;
	hash_type	hash = (map_get(hashs, ST(1), "hash").pointer)
;
	const char *	key = (const char *)SvPV(ST(2), STRLEN_length_of_key);

	XSauto_length_of_key = STRLEN_length_of_key;
#line 1078 "lib/Crypt/Bear.xs"
	RETVAL = safemalloc(sizeof *RETVAL);
	br_hmac_key_init(RETVAL, hash, key, STRLEN_length_of_key);
#line 1429 "lib/Crypt/Bear.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    {
		    sv_setref_pvn(RETVALSV, "Crypt::Bear::HMAC::Key", (const char*)RETVAL, sizeof(*RETVAL));
		    SvREADONLY_on(SvRV(RETVALSV));
	    }
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__HMAC__Key_digest); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__HMAC__Key_digest)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	hash_type	RETVAL;
	Crypt__Bear__HMAC__Key	self;

    {
		SV * sv = ST(0);
		if (SvROK(sv) && sv_derived_from(sv, "Crypt::Bear::HMAC::Key"))
			self = (Crypt__Bear__HMAC__Key)SvPV_nolen(SvRV(sv));
		else
			croak("%s: %s is not of type %s", "Crypt::Bear::HMAC::Key::digest", "self", "Crypt::Bear::HMAC::Key");
    }
;

	RETVAL = br_hmac_key_digest(self);
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    STMT_START {
		    union value value = { .pointer = RETVAL };
		    const entry* entry = map_reverse_find(hashs, value);
		    RETVALSV = entry ? newSVpvn(entry->key, entry->length) : newSV(0);
	    } STMT_END;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__HMAC_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__HMAC_new)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "class, key, out_length= 0");
    {
	Crypt__Bear__HMAC	RETVAL;
	Crypt__Bear__HMAC__Key	key;
	size_t	out_length;

    {
		SV * sv = ST(1);
		if (SvROK(sv) && sv_derived_from(sv, "Crypt::Bear::HMAC::Key"))
			key = (Crypt__Bear__HMAC__Key)SvPV_nolen(SvRV(sv));
		else
			croak("%s: %s is not of type %s", "Crypt::Bear::HMAC::new", "key", "Crypt::Bear::HMAC::Key");
    }
;

	if (items < 3)
	    out_length = 0;
	else {
	    out_length = (size_t)SvUV(ST(2))
;
	}
#line 1089 "lib/Crypt/Bear.xs"
	RETVAL = safemalloc(sizeof *RETVAL);
	br_hmac_init(RETVAL, key, out_length);
#line 1508 "lib/Crypt/Bear.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    {
		    sv_setref_pvn(RETVALSV, "Crypt::Bear::HMAC", (const char*)RETVAL, sizeof(*RETVAL));
		    SvREADONLY_on(SvRV(RETVALSV));
	    }
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__HMAC_size); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__HMAC_size)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	IV	RETVAL;
	dXSTARG;
	Crypt__Bear__HMAC	self;

    {
		SV * sv = ST(0);
		if (SvROK(sv) && sv_derived_from(sv, "Crypt::Bear::HMAC"))
			self = (Crypt__Bear__HMAC)SvPV_nolen(SvRV(sv));
		else
			croak("%s: %s is not of type %s", "Crypt::Bear::HMAC::size", "self", "Crypt::Bear::HMAC");
    }
;

	RETVAL = br_hmac_size(self);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__HMAC_update); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__HMAC_update)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, data");
    {
	STRLEN	STRLEN_length_of_data;
	size_t	XSauto_length_of_data;
	Crypt__Bear__HMAC	self;
	const char *	data = (const char *)SvPV(ST(1), STRLEN_length_of_data);

	XSauto_length_of_data = STRLEN_length_of_data;

    {
		SV * sv = ST(0);
		if (SvROK(sv) && sv_derived_from(sv, "Crypt::Bear::HMAC"))
			self = (Crypt__Bear__HMAC)SvPV_nolen(SvRV(sv));
		else
			croak("%s: %s is not of type %s", "Crypt::Bear::HMAC::update", "self", "Crypt::Bear::HMAC");
    }
;

	br_hmac_update(self, data, XSauto_length_of_data);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__Bear__HMAC_out); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__HMAC_out)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	RETVAL;
	Crypt__Bear__HMAC	self;

    {
		SV * sv = ST(0);
		if (SvROK(sv) && sv_derived_from(sv, "Crypt::Bear::HMAC"))
			self = (Crypt__Bear__HMAC)SvPV_nolen(SvRV(sv));
		else
			croak("%s: %s is not of type %s", "Crypt::Bear::HMAC::out", "self", "Crypt::Bear::HMAC");
    }
;
#line 1100 "lib/Crypt/Bear.xs"
	RETVAL = make_buffer(br_hmac_size(self));
	br_hmac_out(self, SvPVX(RETVAL));
#line 1601 "lib/Crypt/Bear.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__HMAC_digest); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__HMAC_digest)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	hash_type	RETVAL;
	Crypt__Bear__HMAC	self;

    {
		SV * sv = ST(0);
		if (SvROK(sv) && sv_derived_from(sv, "Crypt::Bear::HMAC"))
			self = (Crypt__Bear__HMAC)SvPV_nolen(SvRV(sv));
		else
			croak("%s: %s is not of type %s", "Crypt::Bear::HMAC::digest", "self", "Crypt::Bear::HMAC");
    }
;

	RETVAL = br_hmac_digest(self);
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    STMT_START {
		    union value value = { .pointer = RETVAL };
		    const entry* entry = map_reverse_find(hashs, value);
		    RETVALSV = entry ? newSVpvn(entry->key, entry->length) : newSV(0);
	    } STMT_END;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__HKDF_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__HKDF_new)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "class, hash, salt");
    {
	Crypt__Bear__HKDF	RETVAL;
	STRLEN	STRLEN_length_of_salt;
	size_t	XSauto_length_of_salt;
	hash_type	hash = (map_get(hashs, ST(1), "hash").pointer)
;
	const char *	salt = (const char *)SvPV(ST(2), STRLEN_length_of_salt);

	XSauto_length_of_salt = STRLEN_length_of_salt;
#line 1112 "lib/Crypt/Bear.xs"
	RETVAL = safemalloc(sizeof *RETVAL);
	br_hkdf_init(RETVAL, hash, salt, STRLEN_length_of_salt);
#line 1662 "lib/Crypt/Bear.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    {
		    sv_setref_pvn(RETVALSV, "Crypt::Bear::HKDF", (const char*)RETVAL, sizeof(*RETVAL));
		    SvREADONLY_on(SvRV(RETVALSV));
	    }
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__HKDF_inject); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__HKDF_inject)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, data");
    {
	STRLEN	STRLEN_length_of_data;
	size_t	XSauto_length_of_data;
	Crypt__Bear__HKDF	self;
	const char *	data = (const char *)SvPV(ST(1), STRLEN_length_of_data);

	XSauto_length_of_data = STRLEN_length_of_data;

    {
		SV * sv = ST(0);
		if (SvROK(sv) && sv_derived_from(sv, "Crypt::Bear::HKDF"))
			self = (Crypt__Bear__HKDF)SvPV_nolen(SvRV(sv));
		else
			croak("%s: %s is not of type %s", "Crypt::Bear::HKDF::inject", "self", "Crypt::Bear::HKDF");
    }
;

	br_hkdf_inject(self, data, XSauto_length_of_data);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__Bear__HKDF_flip); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__HKDF_flip)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Crypt__Bear__HKDF	self;

    {
		SV * sv = ST(0);
		if (SvROK(sv) && sv_derived_from(sv, "Crypt::Bear::HKDF"))
			self = (Crypt__Bear__HKDF)SvPV_nolen(SvRV(sv));
		else
			croak("%s: %s is not of type %s", "Crypt::Bear::HKDF::flip", "self", "Crypt::Bear::HKDF");
    }
;

	br_hkdf_flip(self);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__Bear__HKDF_produce); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__HKDF_produce)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, output_size, info");
    {
	SV *	RETVAL;
	STRLEN	STRLEN_length_of_info;
	size_t	XSauto_length_of_info;
	Crypt__Bear__HKDF	self;
	size_t	output_size = (size_t)SvUV(ST(1))
;
	const char *	info = (const char *)SvPV(ST(2), STRLEN_length_of_info);

	XSauto_length_of_info = STRLEN_length_of_info;

    {
		SV * sv = ST(0);
		if (SvROK(sv) && sv_derived_from(sv, "Crypt::Bear::HKDF"))
			self = (Crypt__Bear__HKDF)SvPV_nolen(SvRV(sv));
		else
			croak("%s: %s is not of type %s", "Crypt::Bear::HKDF::produce", "self", "Crypt::Bear::HKDF");
    }
;
#line 1123 "lib/Crypt/Bear.xs"
	RETVAL = make_buffer(output_size);
	br_hkdf_produce(self, info, STRLEN_length_of_info, SvPV_nolen(RETVAL), output_size);
#line 1758 "lib/Crypt/Bear.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}

#if 0
#define XSubPPtmpAAAA 1


XS_EUPXS(XS_Crypt__Bear__Shake_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__Shake_new)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "class, hash, security_level");
    {
	Crypt__Bear__Shake	RETVAL;
	hash_type	hash = (map_get(hashs, ST(1), "hash").pointer)
;
	UV	security_level = (UV)SvUV(ST(2))
;
#line 1134 "lib/Crypt/Bear.xs"
#line 1782 "lib/Crypt/Bear.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    {
		    sv_setref_pvn(RETVALSV, "Crypt::Bear::Shake", (const char*)RETVAL, sizeof(*RETVAL));
		    SvREADONLY_on(SvRV(RETVALSV));
	    }
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__Shake_inject); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__Shake_inject)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, data");
    {
	STRLEN	STRLEN_length_of_data;
	size_t	XSauto_length_of_data;
	Crypt__Bear__Shake	self;
	const char *	data = (const char *)SvPV(ST(1), STRLEN_length_of_data);

	XSauto_length_of_data = STRLEN_length_of_data;

    {
		SV * sv = ST(0);
		if (SvROK(sv) && sv_derived_from(sv, "Crypt::Bear::Shake"))
			self = (Crypt__Bear__Shake)SvPV_nolen(SvRV(sv));
		else
			croak("%s: %s is not of type %s", "Crypt::Bear::Shake::inject", "self", "Crypt::Bear::Shake");
    }
;

	br_shake_inject(self, data, XSauto_length_of_data);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__Bear__Shake_flip); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__Shake_flip)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Crypt__Bear__Shake	self;

    {
		SV * sv = ST(0);
		if (SvROK(sv) && sv_derived_from(sv, "Crypt::Bear::Shake"))
			self = (Crypt__Bear__Shake)SvPV_nolen(SvRV(sv));
		else
			croak("%s: %s is not of type %s", "Crypt::Bear::Shake::flip", "self", "Crypt::Bear::Shake");
    }
;

	br_shake_flip(self);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__Bear__Shake_produce); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__Shake_produce)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, info");
    {
	SV *	RETVAL;
	STRLEN	STRLEN_length_of_info;
	size_t	XSauto_length_of_info;
	Crypt__Bear__Shake	self;
	const char *	info = (const char *)SvPV(ST(1), STRLEN_length_of_info);

	XSauto_length_of_info = STRLEN_length_of_info;

    {
		SV * sv = ST(0);
		if (SvROK(sv) && sv_derived_from(sv, "Crypt::Bear::Shake"))
			self = (Crypt__Bear__Shake)SvPV_nolen(SvRV(sv));
		else
			croak("%s: %s is not of type %s", "Crypt::Bear::Shake::produce", "self", "Crypt::Bear::Shake");
    }
;
#line 1143 "lib/Crypt/Bear.xs"
	RETVAL = make_buffer(output_size);
	br_shake_produce(self, info, STRLEN_length_of_info, SvPV_nolen(RETVAL), output_size);
#line 1876 "lib/Crypt/Bear.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}

#endif

XS_EUPXS(XS_Crypt__Bear__CBC__Enc_block_size); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__CBC__Enc_block_size)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	IV	RETVAL;
	dXSTARG;
	Crypt__Bear__CBC__Enc	self;

    {
		SV * sv = ST(0);
		if (SvROK(sv) && sv_derived_from(sv, "Crypt::Bear::CBC::Enc"))
			self = (Crypt__Bear__CBC__Enc)SvPV_nolen(SvRV(sv));
		else
			croak("%s: %s is not of type %s", "Crypt::Bear::CBC::Enc::block_size", "self", "Crypt::Bear::CBC::Enc");
    }
;

	RETVAL = br_block_cbcenc_block_size(self);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__CBC__Enc_run); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__CBC__Enc_run)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, iv, data");
    {
	SV *	RETVAL;
	STRLEN	STRLEN_length_of_iv;
	STRLEN	XSauto_length_of_iv;
	STRLEN	STRLEN_length_of_data;
	size_t	XSauto_length_of_data;
	Crypt__Bear__CBC__Enc	self;
	const char *	iv = (const char *)SvPV(ST(1), STRLEN_length_of_iv);
	const char *	data = (const char *)SvPV(ST(2), STRLEN_length_of_data);

	XSauto_length_of_iv = STRLEN_length_of_iv;

	XSauto_length_of_data = STRLEN_length_of_data;

    {
		SV * sv = ST(0);
		if (SvROK(sv) && sv_derived_from(sv, "Crypt::Bear::CBC::Enc"))
			self = (Crypt__Bear__CBC__Enc)SvPV_nolen(SvRV(sv));
		else
			croak("%s: %s is not of type %s", "Crypt::Bear::CBC::Enc::run", "self", "Crypt::Bear::CBC::Enc");
    }
;
#line 1157 "lib/Crypt/Bear.xs"
	if ((STRLEN_length_of_data % br_block_cbcenc_block_size(self)) != 0)
		Perl_croak(aTHX_ "Data size should be a multiple of %u bytes", br_block_cbcenc_block_size(self));
	if (STRLEN_length_of_iv != br_block_cbcenc_block_size(self))
		Perl_croak(aTHX_ "IV should be %u bytes", br_block_cbcenc_block_size(self));

	char iv_copy[STRLEN_length_of_iv];
	memcpy(iv_copy, iv, STRLEN_length_of_iv);
	RETVAL = newSVpvn(data, STRLEN_length_of_data);
	((*self)->run)(self, iv_copy, SvPV_nolen(RETVAL), STRLEN_length_of_data);
#line 1951 "lib/Crypt/Bear.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__CBC__Dec_block_size); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__CBC__Dec_block_size)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	IV	RETVAL;
	dXSTARG;
	Crypt__Bear__CBC__Dec	self;

    {
		SV * sv = ST(0);
		if (SvROK(sv) && sv_derived_from(sv, "Crypt::Bear::CBC::Dec"))
			self = (Crypt__Bear__CBC__Dec)SvPV_nolen(SvRV(sv));
		else
			croak("%s: %s is not of type %s", "Crypt::Bear::CBC::Dec::block_size", "self", "Crypt::Bear::CBC::Dec");
    }
;

	RETVAL = br_block_cbcdec_block_size(self);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__CBC__Dec_run); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__CBC__Dec_run)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, iv, data");
    {
	SV *	RETVAL;
	STRLEN	STRLEN_length_of_iv;
	STRLEN	XSauto_length_of_iv;
	STRLEN	STRLEN_length_of_data;
	size_t	XSauto_length_of_data;
	Crypt__Bear__CBC__Dec	self;
	const char *	iv = (const char *)SvPV(ST(1), STRLEN_length_of_iv);
	const char *	data = (const char *)SvPV(ST(2), STRLEN_length_of_data);

	XSauto_length_of_iv = STRLEN_length_of_iv;

	XSauto_length_of_data = STRLEN_length_of_data;

    {
		SV * sv = ST(0);
		if (SvROK(sv) && sv_derived_from(sv, "Crypt::Bear::CBC::Dec"))
			self = (Crypt__Bear__CBC__Dec)SvPV_nolen(SvRV(sv));
		else
			croak("%s: %s is not of type %s", "Crypt::Bear::CBC::Dec::run", "self", "Crypt::Bear::CBC::Dec");
    }
;
#line 1176 "lib/Crypt/Bear.xs"
	if ((STRLEN_length_of_data % br_block_cbcdec_block_size(self)) != 0)
		Perl_croak(aTHX_ "data size should be a multiple of %u bytes", br_block_cbcdec_block_size(self));
	if (STRLEN_length_of_iv != br_block_cbcdec_block_size(self))
		Perl_croak(aTHX_ "IV should be %u bytes", br_block_cbcdec_block_size(self));

	char iv_copy[STRLEN_length_of_iv];
	memcpy(iv_copy, iv, STRLEN_length_of_iv);
	RETVAL = newSVpvn(data, STRLEN_length_of_data);
	((*self)->run)(self, iv_copy, SvPV_nolen(RETVAL), STRLEN_length_of_data);
#line 2025 "lib/Crypt/Bear.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__CTR_block_size); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__CTR_block_size)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	IV	RETVAL;
	dXSTARG;
	Crypt__Bear__CTR	self;

    {
		SV * sv = ST(0);
		if (SvROK(sv) && sv_derived_from(sv, "Crypt::Bear::CTR"))
			self = (Crypt__Bear__CTR)SvPV_nolen(SvRV(sv));
		else
			croak("%s: %s is not of type %s", "Crypt::Bear::CTR::block_size", "self", "Crypt::Bear::CTR");
    }
;

	RETVAL = br_block_ctr_block_size(self);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__CTR_run); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__CTR_run)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "self, iv, counter, data");
    {
	SV *	RETVAL;
	STRLEN	STRLEN_length_of_iv;
	STRLEN	XSauto_length_of_iv;
	STRLEN	STRLEN_length_of_data;
	size_t	XSauto_length_of_data;
	Crypt__Bear__CTR	self;
	const char *	iv = (const char *)SvPV(ST(1), STRLEN_length_of_iv);
	U32	counter = (unsigned long)SvUV(ST(2))
;
	const char *	data = (const char *)SvPV(ST(3), STRLEN_length_of_data);

	XSauto_length_of_iv = STRLEN_length_of_iv;

	XSauto_length_of_data = STRLEN_length_of_data;

    {
		SV * sv = ST(0);
		if (SvROK(sv) && sv_derived_from(sv, "Crypt::Bear::CTR"))
			self = (Crypt__Bear__CTR)SvPV_nolen(SvRV(sv));
		else
			croak("%s: %s is not of type %s", "Crypt::Bear::CTR::run", "self", "Crypt::Bear::CTR");
    }
;
#line 1195 "lib/Crypt/Bear.xs"
	if ((STRLEN_length_of_data % br_block_ctr_block_size(self)) != 0)
		Perl_croak(aTHX_ "data size should be a multiple of %u bytes", br_block_ctr_block_size(self));
	if (STRLEN_length_of_iv != br_block_ctr_block_size(self))
		Perl_croak(aTHX_ "IV should be %u bytes", br_block_ctr_block_size(self));

	char iv_copy[STRLEN_length_of_iv];
	memcpy(iv_copy, iv, STRLEN_length_of_iv);
	RETVAL = newSVpvn(data, STRLEN_length_of_data);
	((*self)->run)(self, iv_copy, counter, SvPV_nolen(RETVAL), STRLEN_length_of_data);
#line 2101 "lib/Crypt/Bear.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__AES_CBC__Enc_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__AES_CBC__Enc_new)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "class, key");
    {
	Crypt__Bear__AES_CBC__Enc	RETVAL;
	STRLEN	STRLEN_length_of_key;
	size_t	XSauto_length_of_key;
	const char *	key = (const char *)SvPV(ST(1), STRLEN_length_of_key);

	XSauto_length_of_key = STRLEN_length_of_key;
#line 1217 "lib/Crypt/Bear.xs"
	RETVAL = safemalloc(aes_cbc_enc->context_size);
	(aes_cbc_enc->init)((const br_block_cbcenc_class**)RETVAL, key, STRLEN_length_of_key);
#line 2125 "lib/Crypt/Bear.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    {
		    sv_setref_pvn(RETVALSV, "Crypt::Bear::AES_CBC::Enc", (const char*)RETVAL, sizeof(*RETVAL));
		    SvREADONLY_on(SvRV(RETVALSV));
	    }
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__AES_CBC__Dec_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__AES_CBC__Dec_new)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "class, key");
    {
	Crypt__Bear__AES_CBC__Dec	RETVAL;
	STRLEN	STRLEN_length_of_key;
	size_t	XSauto_length_of_key;
	const char *	key = (const char *)SvPV(ST(1), STRLEN_length_of_key);

	XSauto_length_of_key = STRLEN_length_of_key;
#line 1236 "lib/Crypt/Bear.xs"
	RETVAL = safemalloc(aes_cbc_dec->context_size);
	(aes_cbc_dec->init)((const br_block_cbcdec_class**)RETVAL, key, STRLEN_length_of_key);
#line 2156 "lib/Crypt/Bear.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    {
		    sv_setref_pvn(RETVALSV, "Crypt::Bear::AES_CBC::Dec", (const char*)RETVAL, sizeof(*RETVAL));
		    SvREADONLY_on(SvRV(RETVALSV));
	    }
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__AES_CTR_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__AES_CTR_new)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "class, key");
    {
	Crypt__Bear__AES_CTR	RETVAL;
	STRLEN	STRLEN_length_of_key;
	size_t	XSauto_length_of_key;
	const char *	key = (const char *)SvPV(ST(1), STRLEN_length_of_key);

	XSauto_length_of_key = STRLEN_length_of_key;
#line 1255 "lib/Crypt/Bear.xs"
	RETVAL = safemalloc(aes_ctr->context_size);
	(aes_ctr->init)(&RETVAL->vtable, key, STRLEN_length_of_key);
#line 2187 "lib/Crypt/Bear.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    {
		    sv_setref_pvn(RETVALSV, "Crypt::Bear::AES_CTR", (const char*)RETVAL, sizeof(*RETVAL));
		    SvREADONLY_on(SvRV(RETVALSV));
	    }
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__AES_CTRCBC_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__AES_CTRCBC_new)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "class, data");
    {
	Crypt__Bear__AES_CTRCBC	RETVAL;
	STRLEN	STRLEN_length_of_data;
	size_t	XSauto_length_of_data;
	const char *	data = (const char *)SvPV(ST(1), STRLEN_length_of_data);

	XSauto_length_of_data = STRLEN_length_of_data;
#line 1272 "lib/Crypt/Bear.xs"
	RETVAL = safemalloc(aes_ctrcbc->context_size);
	(aes_ctrcbc->init)(&RETVAL->vtable, data, STRLEN_length_of_data);
#line 2218 "lib/Crypt/Bear.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    {
		    sv_setref_pvn(RETVALSV, "Crypt::Bear::AES_CTRCBC", (const char*)RETVAL, sizeof(*RETVAL));
		    SvREADONLY_on(SvRV(RETVALSV));
	    }
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__AEAD_reset); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__AEAD_reset)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, iv");
    {
	STRLEN	STRLEN_length_of_iv;
	size_t	XSauto_length_of_iv;
	Crypt__Bear__AEAD	self;
	const char *	iv = (const char *)SvPV(ST(1), STRLEN_length_of_iv);

	XSauto_length_of_iv = STRLEN_length_of_iv;

    {
		SV * sv = ST(0);
		if (SvROK(sv) && sv_derived_from(sv, "Crypt::Bear::AEAD"))
			self = (Crypt__Bear__AEAD)SvPV_nolen(SvRV(sv));
		else
			croak("%s: %s is not of type %s", "Crypt::Bear::AEAD::reset", "self", "Crypt::Bear::AEAD");
    }
;

	br_aead_reset(self, iv, XSauto_length_of_iv);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__Bear__AEAD_aad_inject); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__AEAD_aad_inject)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, iv");
    {
	STRLEN	STRLEN_length_of_iv;
	size_t	XSauto_length_of_iv;
	Crypt__Bear__AEAD	self;
	const char *	iv = (const char *)SvPV(ST(1), STRLEN_length_of_iv);

	XSauto_length_of_iv = STRLEN_length_of_iv;

    {
		SV * sv = ST(0);
		if (SvROK(sv) && sv_derived_from(sv, "Crypt::Bear::AEAD"))
			self = (Crypt__Bear__AEAD)SvPV_nolen(SvRV(sv));
		else
			croak("%s: %s is not of type %s", "Crypt::Bear::AEAD::aad_inject", "self", "Crypt::Bear::AEAD");
    }
;

	br_aead_aad_inject(self, iv, XSauto_length_of_iv);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__Bear__AEAD_flip); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__AEAD_flip)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Crypt__Bear__AEAD	self;

    {
		SV * sv = ST(0);
		if (SvROK(sv) && sv_derived_from(sv, "Crypt::Bear::AEAD"))
			self = (Crypt__Bear__AEAD)SvPV_nolen(SvRV(sv));
		else
			croak("%s: %s is not of type %s", "Crypt::Bear::AEAD::flip", "self", "Crypt::Bear::AEAD");
    }
;

	br_aead_flip(self);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__Bear__AEAD_run); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__AEAD_run)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, data, encrypt");
    {
	SV *	RETVAL;
	STRLEN	STRLEN_length_of_data;
	size_t	XSauto_length_of_data;
	Crypt__Bear__AEAD	self;
	const char *	data = (const char *)SvPV(ST(1), STRLEN_length_of_data);
	bool	encrypt = (bool)SvTRUE(ST(2))
;

	XSauto_length_of_data = STRLEN_length_of_data;

    {
		SV * sv = ST(0);
		if (SvROK(sv) && sv_derived_from(sv, "Crypt::Bear::AEAD"))
			self = (Crypt__Bear__AEAD)SvPV_nolen(SvRV(sv));
		else
			croak("%s: %s is not of type %s", "Crypt::Bear::AEAD::run", "self", "Crypt::Bear::AEAD");
    }
;
#line 1291 "lib/Crypt/Bear.xs"
	RETVAL = newSVpvn(data, STRLEN_length_of_data);
	br_aead_run(self, encrypt, SvPV_nolen(RETVAL), STRLEN_length_of_data);
#line 2343 "lib/Crypt/Bear.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__AEAD_get_tag); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__AEAD_get_tag)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	RETVAL;
	Crypt__Bear__AEAD	self;

    {
		SV * sv = ST(0);
		if (SvROK(sv) && sv_derived_from(sv, "Crypt::Bear::AEAD"))
			self = (Crypt__Bear__AEAD)SvPV_nolen(SvRV(sv));
		else
			croak("%s: %s is not of type %s", "Crypt::Bear::AEAD::get_tag", "self", "Crypt::Bear::AEAD");
    }
;
#line 1298 "lib/Crypt/Bear.xs"
	RETVAL = make_buffer((*self)->tag_size);
	br_aead_get_tag(self, SvPVX(RETVAL));
#line 2372 "lib/Crypt/Bear.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__AEAD_check_tag); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__AEAD_check_tag)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, tag");
    {
	bool	RETVAL;
	STRLEN	STRLEN_length_of_tag;
	size_t	XSauto_length_of_tag;
	Crypt__Bear__AEAD	self;
	const char *	tag = (const char *)SvPV(ST(1), STRLEN_length_of_tag);

	XSauto_length_of_tag = STRLEN_length_of_tag;

    {
		SV * sv = ST(0);
		if (SvROK(sv) && sv_derived_from(sv, "Crypt::Bear::AEAD"))
			self = (Crypt__Bear__AEAD)SvPV_nolen(SvRV(sv));
		else
			croak("%s: %s is not of type %s", "Crypt::Bear::AEAD::check_tag", "self", "Crypt::Bear::AEAD");
    }
;
#line 1305 "lib/Crypt/Bear.xs"
	if (STRLEN_length_of_tag != (*self)->tag_size)
		Perl_croak(aTHX_ "Incorrect tag size, got %zu expected %zu", STRLEN_length_of_tag, (*self)->tag_size);
	RETVAL = br_aead_check_tag(self, tag);
#line 2407 "lib/Crypt/Bear.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__GCM_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__GCM_new)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "class, ctr");
    {
	Crypt__Bear__GCM	RETVAL;
	Crypt__Bear__CTR	ctr;

    {
		SV * sv = ST(1);
		if (SvROK(sv) && sv_derived_from(sv, "Crypt::Bear::CTR"))
			ctr = (Crypt__Bear__CTR)SvPV_nolen(SvRV(sv));
		else
			croak("%s: %s is not of type %s", "Crypt::Bear::GCM::new", "ctr", "Crypt::Bear::CTR");
    }
;
#line 1326 "lib/Crypt/Bear.xs"
	RETVAL = safemalloc(sizeof *RETVAL);
	br_gcm_init(RETVAL, ctr, ghash_impl);
#line 2435 "lib/Crypt/Bear.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    {
		    sv_setref_pvn(RETVALSV, "Crypt::Bear::GCM", (const char*)RETVAL, sizeof(*RETVAL));
		    SvREADONLY_on(SvRV(RETVALSV));
	    }
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__EAX_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__EAX_new)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "class, ctrcbc");
    {
	Crypt__Bear__EAX	RETVAL;
	Crypt__Bear__CTRCBC	ctrcbc;

    {
		SV * sv = ST(1);
		if (SvROK(sv) && sv_derived_from(sv, "Crypt::Bear::CTRCBC"))
			ctrcbc = (Crypt__Bear__CTRCBC)SvPV_nolen(SvRV(sv));
		else
			croak("%s: %s is not of type %s", "Crypt::Bear::EAX::new", "ctrcbc", "Crypt::Bear::CTRCBC");
    }
;
#line 1338 "lib/Crypt/Bear.xs"
	RETVAL = safemalloc(sizeof *RETVAL);
	br_eax_init(RETVAL, ctrcbc);
#line 2471 "lib/Crypt/Bear.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    {
		    sv_setref_pvn(RETVALSV, "Crypt::Bear::EAX", (const char*)RETVAL, sizeof(*RETVAL));
		    SvREADONLY_on(SvRV(RETVALSV));
	    }
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__CCM_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__CCM_new)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "class, ctrcbc");
    {
	Crypt__Bear__CCM	RETVAL;
	Crypt__Bear__CTRCBC	ctrcbc;

    {
		SV * sv = ST(1);
		if (SvROK(sv) && sv_derived_from(sv, "Crypt::Bear::CTRCBC"))
			ctrcbc = (Crypt__Bear__CTRCBC)SvPV_nolen(SvRV(sv));
		else
			croak("%s: %s is not of type %s", "Crypt::Bear::CCM::new", "ctrcbc", "Crypt::Bear::CTRCBC");
    }
;
#line 1350 "lib/Crypt/Bear.xs"
	RETVAL = safemalloc(sizeof *RETVAL);
	br_ccm_init(RETVAL, ctrcbc);
#line 2507 "lib/Crypt/Bear.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    {
		    sv_setref_pvn(RETVALSV, "Crypt::Bear::CCM", (const char*)RETVAL, sizeof(*RETVAL));
		    SvREADONLY_on(SvRV(RETVALSV));
	    }
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__PRNG_system_seeder_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__PRNG_system_seeder_name)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "class");
    {
	const char *	RETVAL;
	dXSTARG;

	RETVAL = br_prng_system_seeder_name(class);
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__PRNG_generate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__PRNG_generate)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, length");
    {
	SV *	RETVAL;
	Crypt__Bear__PRNG	self;
	size_t	length = (size_t)SvUV(ST(1))
;

    {
		SV * sv = ST(0);
		if (SvROK(sv) && sv_derived_from(sv, "Crypt::Bear::PRNG"))
			self = (Crypt__Bear__PRNG)SvPV_nolen(SvRV(sv));
		else
			croak("%s: %s is not of type %s", "Crypt::Bear::PRNG::generate", "self", "Crypt::Bear::PRNG");
    }
;
#line 1364 "lib/Crypt/Bear.xs"
	RETVAL = make_buffer(length);
	((*self)->generate)(self, SvPVX(RETVAL), length);
#line 2564 "lib/Crypt/Bear.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__PRNG_update); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__PRNG_update)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, data");
    {
	STRLEN	STRLEN_length_of_data;
	size_t	XSauto_length_of_data;
	Crypt__Bear__PRNG	self;
	const char *	data = (const char *)SvPV(ST(1), STRLEN_length_of_data);

	XSauto_length_of_data = STRLEN_length_of_data;

    {
		SV * sv = ST(0);
		if (SvROK(sv) && sv_derived_from(sv, "Crypt::Bear::PRNG"))
			self = (Crypt__Bear__PRNG)SvPV_nolen(SvRV(sv));
		else
			croak("%s: %s is not of type %s", "Crypt::Bear::PRNG::update", "self", "Crypt::Bear::PRNG");
    }
;

	br_prng_update(self, data, XSauto_length_of_data);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__Bear__PRNG_system_seed); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__PRNG_system_seed)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	bool	RETVAL;
	Crypt__Bear__PRNG	self;

    {
		SV * sv = ST(0);
		if (SvROK(sv) && sv_derived_from(sv, "Crypt::Bear::PRNG"))
			self = (Crypt__Bear__PRNG)SvPV_nolen(SvRV(sv));
		else
			croak("%s: %s is not of type %s", "Crypt::Bear::PRNG::system_seed", "self", "Crypt::Bear::PRNG");
    }
;
#line 1373 "lib/Crypt/Bear.xs"
	RETVAL = system_seeder ? system_seeder(self) : false;
#line 2621 "lib/Crypt/Bear.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__HMAC__DRBG_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__HMAC__DRBG_new)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "class, hash, seed");
    {
	Crypt__Bear__HMAC__DRBG	RETVAL;
	STRLEN	STRLEN_length_of_seed;
	size_t	XSauto_length_of_seed;
	hash_type	hash = (map_get(hashs, ST(1), "hash").pointer)
;
	const char *	seed = (const char *)SvPV(ST(2), STRLEN_length_of_seed);

	XSauto_length_of_seed = STRLEN_length_of_seed;
#line 1384 "lib/Crypt/Bear.xs"
	RETVAL = safemalloc(sizeof *RETVAL);
	br_hmac_drbg_init(RETVAL, hash, seed, STRLEN_length_of_seed);
#line 2646 "lib/Crypt/Bear.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    {
		    sv_setref_pvn(RETVALSV, "Crypt::Bear::HMAC::DRBG", (const char*)RETVAL, sizeof(*RETVAL));
		    SvREADONLY_on(SvRV(RETVALSV));
	    }
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__HMAC__DRBG_digest); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__HMAC__DRBG_digest)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	hash_type	RETVAL;
	Crypt__Bear__HMAC__DRBG	self;

    {
		SV * sv = ST(0);
		if (SvROK(sv) && sv_derived_from(sv, "Crypt::Bear::HMAC::DRBG"))
			self = (Crypt__Bear__HMAC__DRBG)SvPV_nolen(SvRV(sv));
		else
			croak("%s: %s is not of type %s", "Crypt::Bear::HMAC::DRBG::digest", "self", "Crypt::Bear::HMAC::DRBG");
    }
;

	RETVAL = br_hmac_drbg_digest(self);
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    STMT_START {
		    union value value = { .pointer = RETVAL };
		    const entry* entry = map_reverse_find(hashs, value);
		    RETVALSV = entry ? newSVpvn(entry->key, entry->length) : newSV(0);
	    } STMT_END;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__AES_CTR__DRBG_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__AES_CTR__DRBG_new)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "class, seed");
    {
	Crypt__Bear__AES_CTR__DRBG	RETVAL;
	STRLEN	STRLEN_length_of_seed;
	size_t	XSauto_length_of_seed;
	const char *	seed = (const char *)SvPV(ST(1), STRLEN_length_of_seed);

	XSauto_length_of_seed = STRLEN_length_of_seed;
#line 1399 "lib/Crypt/Bear.xs"
	RETVAL = safemalloc(sizeof *RETVAL);
	br_aesctr_drbg_init(RETVAL, aes_ctr, seed, STRLEN_length_of_seed);
#line 2712 "lib/Crypt/Bear.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    {
		    sv_setref_pvn(RETVALSV, "Crypt::Bear::AES_CTR::DRBG", (const char*)RETVAL, sizeof(*RETVAL));
		    SvREADONLY_on(SvRV(RETVALSV));
	    }
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__RSA_generate_keypair); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__RSA_generate_keypair)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "prng, size, exponent= 0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Crypt__Bear__PRNG	prng;
	size_t	size = (size_t)SvUV(ST(1))
;
	UV	exponent;

    {
		SV * sv = ST(0);
		if (SvROK(sv) && sv_derived_from(sv, "Crypt::Bear::PRNG"))
			prng = (Crypt__Bear__PRNG)SvPV_nolen(SvRV(sv));
		else
			croak("%s: %s is not of type %s", "Crypt::Bear::RSA::generate_keypair", "prng", "Crypt::Bear::PRNG");
    }
;

	if (items < 3)
	    exponent = 0;
	else {
	    exponent = (UV)SvUV(ST(2))
;
	}
#line 1411 "lib/Crypt/Bear.xs"
	br_rsa_public_key* key = safemalloc(sizeof(br_rsa_public_key));
	char* public_buffer = safemalloc(BR_RSA_KBUF_PUB_SIZE(size));
	br_rsa_private_key* private_key = safemalloc(sizeof(br_rsa_private_key));
	char* private_buffer = safemalloc(BR_RSA_KBUF_PRIV_SIZE(size));
	bool success = rsa_keygen(prng, private_key, private_buffer, key, public_buffer, size, exponent);

	if (success) {
		SV* public = make_magic(key, "Crypt::Bear::RSA::PublicKey", &Crypt__Bear__RSA__PublicKey_magic);
		mXPUSHs(public);

		SV* private = make_magic(private_key, "Crypt::Bear::RSA::PrivateKey", &Crypt__Bear__RSA__PrivateKey_magic);
		mXPUSHs(private);
	}
#line 2770 "lib/Crypt/Bear.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Crypt__Bear__RSA__PublicKey_pkcs1_verify); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__RSA__PublicKey_pkcs1_verify)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, hash, signature");
    {
	SV *	RETVAL;
	STRLEN	STRLEN_length_of_signature;
	size_t	XSauto_length_of_signature;
	Crypt__Bear__RSA__PublicKey	self;
	hash_oid_type	hash = (map_get(hash_oids, ST(1), "hash_oid").pointer)
;
	const unsigned char *	signature = (const unsigned char *)SvPV(ST(2), STRLEN_length_of_signature);

	XSauto_length_of_signature = STRLEN_length_of_signature;

	{
	%:ifdef mg_findext
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_findext(SvRV(ST(0)), PERL_MAGIC_ext, &Crypt__Bear__RSA__PublicKey_magic) : NULL;
	%:else
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_find(SvRV(ST(0)), PERL_MAGIC_ext) : NULL;
	%:endif
	if (magic)
		self = (Crypt__Bear__RSA__PublicKey)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::RSA::PublicKey object is lacking magic");
	}
;
#line 1433 "lib/Crypt/Bear.xs"
	RETVAL = make_buffer(hash->length);
	bool success = rsa_pkcs1_verify(signature, STRLEN_length_of_signature, hash->oid, hash->length, self, (unsigned char*)SvPV_nolen(RETVAL));
	if (!success)
		sv_setsv(RETVAL, &PL_sv_undef);
#line 2811 "lib/Crypt/Bear.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__RSA__PublicKey_oaep_encrypt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__RSA__PublicKey_oaep_encrypt)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "self, hash, plain, prng, label");
    {
	SV *	RETVAL;
	STRLEN	STRLEN_length_of_plain;
	size_t	XSauto_length_of_plain;
	STRLEN	STRLEN_length_of_label;
	size_t	XSauto_length_of_label;
	Crypt__Bear__RSA__PublicKey	self;
	hash_type	hash = (map_get(hashs, ST(1), "hash").pointer)
;
	const char *	plain = (const char *)SvPV(ST(2), STRLEN_length_of_plain);
	Crypt__Bear__PRNG	prng;
	const char *	label = (const char *)SvPV(ST(4), STRLEN_length_of_label);

	XSauto_length_of_plain = STRLEN_length_of_plain;

	XSauto_length_of_label = STRLEN_length_of_label;

	{
	%:ifdef mg_findext
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_findext(SvRV(ST(0)), PERL_MAGIC_ext, &Crypt__Bear__RSA__PublicKey_magic) : NULL;
	%:else
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_find(SvRV(ST(0)), PERL_MAGIC_ext) : NULL;
	%:endif
	if (magic)
		self = (Crypt__Bear__RSA__PublicKey)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::RSA::PublicKey object is lacking magic");
	}
;

    {
		SV * sv = ST(3);
		if (SvROK(sv) && sv_derived_from(sv, "Crypt::Bear::PRNG"))
			prng = (Crypt__Bear__PRNG)SvPV_nolen(SvRV(sv));
		else
			croak("%s: %s is not of type %s", "Crypt::Bear::RSA::PublicKey::oaep_encrypt", "prng", "Crypt::Bear::PRNG");
    }
;
#line 1442 "lib/Crypt/Bear.xs"
	RETVAL = make_buffer(self->nlen);
	size_t length = rsa_oaep_encrypt(prng, hash, label, STRLEN_length_of_label, self, SvPV_nolen(RETVAL), self->nlen, plain, STRLEN_length_of_plain);
	if (length)
		SvCUR_set(RETVAL, length);
	else
		Perl_croak(aTHX_ "Could not encrypt");
#line 2870 "lib/Crypt/Bear.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__RSA__PrivateKey_pkcs1_sign); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__RSA__PrivateKey_pkcs1_sign)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, hash_oid, hash");
    {
	SV *	RETVAL;
	STRLEN	STRLEN_length_of_hash;
	size_t	XSauto_length_of_hash;
	Crypt__Bear__RSA__PrivateKey	self;
	hash_oid_type	hash_oid = (map_get(hash_oids, ST(1), "hash_oid").pointer)
;
	const unsigned char *	hash = (const unsigned char *)SvPV(ST(2), STRLEN_length_of_hash);

	XSauto_length_of_hash = STRLEN_length_of_hash;

	{
	%:ifdef mg_findext
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_findext(SvRV(ST(0)), PERL_MAGIC_ext, &Crypt__Bear__RSA__PrivateKey_magic) : NULL;
	%:else
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_find(SvRV(ST(0)), PERL_MAGIC_ext) : NULL;
	%:endif
	if (magic)
		self = (Crypt__Bear__RSA__PrivateKey)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::RSA::PrivateKey object is lacking magic");
	}
;
#line 1460 "lib/Crypt/Bear.xs"
	if (STRLEN_length_of_hash != hash_oid->length)
		Perl_croak(aTHX_ "Hash has incorrect length");
	RETVAL = make_buffer((self->n_bitlen+7)/8);
	bool success = rsa_pkcs1_sign(hash_oid->oid, hash, STRLEN_length_of_hash, self, (unsigned char*)SvPV_nolen(RETVAL));
	if (!success)
		Perl_croak(aTHX_ "Could not sign");
#line 2914 "lib/Crypt/Bear.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__RSA__PrivateKey_oaep_decrypt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__RSA__PrivateKey_oaep_decrypt)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "self, hash, ciphertext, label");
    {
	SV *	RETVAL;
	STRLEN	STRLEN_length_of_ciphertext;
	size_t	XSauto_length_of_ciphertext;
	STRLEN	STRLEN_length_of_label;
	size_t	XSauto_length_of_label;
	Crypt__Bear__RSA__PrivateKey	self;
	hash_type	hash = (map_get(hashs, ST(1), "hash").pointer)
;
	const char *	ciphertext = (const char *)SvPV(ST(2), STRLEN_length_of_ciphertext);
	const char *	label = (const char *)SvPV(ST(3), STRLEN_length_of_label);

	XSauto_length_of_ciphertext = STRLEN_length_of_ciphertext;

	XSauto_length_of_label = STRLEN_length_of_label;

	{
	%:ifdef mg_findext
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_findext(SvRV(ST(0)), PERL_MAGIC_ext, &Crypt__Bear__RSA__PrivateKey_magic) : NULL;
	%:else
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_find(SvRV(ST(0)), PERL_MAGIC_ext) : NULL;
	%:endif
	if (magic)
		self = (Crypt__Bear__RSA__PrivateKey)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::RSA::PrivateKey object is lacking magic");
	}
;
#line 1471 "lib/Crypt/Bear.xs"
	RETVAL = newSVpvn(ciphertext, STRLEN_length_of_ciphertext);
	size_t len = STRLEN_length_of_ciphertext;
	bool succes = rsa_oaep_decrypt(hash, label, STRLEN_length_of_label, self, SvPV_nolen(RETVAL), &len);
	if (succes)
		SvCUR_set(RETVAL, len);
	else
		sv_setsv(RETVAL, &PL_sv_undef);
#line 2964 "lib/Crypt/Bear.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__EC_supported_curves); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__EC_supported_curves)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "class");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 1490 "lib/Crypt/Bear.xs"
	for (UV i = 0; i < 31; i++) {
		if (ec_default->supported_curves & (1 << i)) {
			union value value = { .integer = i };
			const entry* entry = map_reverse_find(curves, value);
			mXPUSHp(entry->key, entry->length);
		}
	}
#line 2989 "lib/Crypt/Bear.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Crypt__Bear__EC__PublicKey_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__EC__PublicKey_new)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "curve, data");
    {
	Crypt__Bear__EC__PublicKey	RETVAL;
	STRLEN	STRLEN_length_of_data;
	size_t	XSauto_length_of_data;
	curve_type	curve = (map_get(curves, ST(0), "curve").integer)
;
	const char *	data = (const char *)SvPV(ST(1), STRLEN_length_of_data);

	XSauto_length_of_data = STRLEN_length_of_data;
#line 1503 "lib/Crypt/Bear.xs"
	RETVAL = safemalloc(sizeof *RETVAL);
	RETVAL->curve = curve;
	RETVAL->q = saveupvn(data, STRLEN_length_of_data);
	RETVAL->qlen = STRLEN_length_of_data;
#line 3016 "lib/Crypt/Bear.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    {
	    MAGIC* magic = sv_magicext(newSVrv(RETVALSV, "Crypt::Bear::EC::PublicKey"), NULL, PERL_MAGIC_ext, &Crypt__Bear__EC__PublicKey_magic, (const char*)RETVAL, 0);
	    magic->mg_flags |= MGf_COPY|MGf_DUP;
	    }
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__EC__PublicKey_curve); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__EC__PublicKey_curve)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	curve_type	RETVAL;
	Crypt__Bear__EC__PublicKey	self;

	{
	%:ifdef mg_findext
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_findext(SvRV(ST(0)), PERL_MAGIC_ext, &Crypt__Bear__EC__PublicKey_magic) : NULL;
	%:else
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_find(SvRV(ST(0)), PERL_MAGIC_ext) : NULL;
	%:endif
	if (magic)
		self = (Crypt__Bear__EC__PublicKey)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::EC::PublicKey object is lacking magic");
	}
;
#line 1512 "lib/Crypt/Bear.xs"
	RETVAL = self->curve;
#line 3055 "lib/Crypt/Bear.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    STMT_START {
		    union value value = { .integer = RETVAL };
		    const entry* entry = map_reverse_find(curves, value);
		    RETVALSV = entry ? newSVpvn(entry->key, entry->length) : newSV(0);
	    } STMT_END;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__EC__PublicKey_ecdsa_verify); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__EC__PublicKey_ecdsa_verify)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "self, hash_name, hash_value, signature");
    {
	bool	RETVAL;
	STRLEN	STRLEN_length_of_hash_value;
	size_t	XSauto_length_of_hash_value;
	STRLEN	STRLEN_length_of_signature;
	size_t	XSauto_length_of_signature;
	Crypt__Bear__EC__PublicKey	self;
	hash_type	hash_name = (map_get(hashs, ST(1), "hash").pointer)
;
	unsigned char *	hash_value = (unsigned char *)SvPV(ST(2), STRLEN_length_of_hash_value);
	unsigned char *	signature = (unsigned char *)SvPV(ST(3), STRLEN_length_of_signature);

	XSauto_length_of_hash_value = STRLEN_length_of_hash_value;

	XSauto_length_of_signature = STRLEN_length_of_signature;

	{
	%:ifdef mg_findext
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_findext(SvRV(ST(0)), PERL_MAGIC_ext, &Crypt__Bear__EC__PublicKey_magic) : NULL;
	%:else
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_find(SvRV(ST(0)), PERL_MAGIC_ext) : NULL;
	%:endif
	if (magic)
		self = (Crypt__Bear__EC__PublicKey)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::EC::PublicKey object is lacking magic");
	}
;
#line 1518 "lib/Crypt/Bear.xs"
	size_t hash_size = ((hash_name->desc >> BR_HASHDESC_OUT_OFF) & BR_HASHDESC_OUT_MASK);
	if (STRLEN_length_of_hash_value != hash_size)
		Perl_croak(aTHX_ "Hash is inappropriately sized");
	RETVAL = ec_verify_default(ec_default, hash_value, hash_size, self, signature, STRLEN_length_of_signature);
#line 3110 "lib/Crypt/Bear.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__EC__PrivateKey_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__EC__PrivateKey_new)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "curve, data");
    {
	Crypt__Bear__EC__PrivateKey	RETVAL;
	STRLEN	STRLEN_length_of_data;
	size_t	XSauto_length_of_data;
	curve_type	curve = (map_get(curves, ST(0), "curve").integer)
;
	const char *	data = (const char *)SvPV(ST(1), STRLEN_length_of_data);

	XSauto_length_of_data = STRLEN_length_of_data;
#line 1530 "lib/Crypt/Bear.xs"
	RETVAL = safemalloc(sizeof *RETVAL);
	RETVAL->curve = curve;
	RETVAL->x = saveupvn(data, STRLEN_length_of_data);
	RETVAL->xlen = STRLEN_length_of_data;
#line 3137 "lib/Crypt/Bear.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    {
	    MAGIC* magic = sv_magicext(newSVrv(RETVALSV, "Crypt::Bear::EC::PrivateKey"), NULL, PERL_MAGIC_ext, &Crypt__Bear__EC__PrivateKey_magic, (const char*)RETVAL, 0);
	    magic->mg_flags |= MGf_COPY|MGf_DUP;
	    }
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__EC__PrivateKey_curve); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__EC__PrivateKey_curve)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	curve_type	RETVAL;
	Crypt__Bear__EC__PrivateKey	self;

	{
	%:ifdef mg_findext
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_findext(SvRV(ST(0)), PERL_MAGIC_ext, &Crypt__Bear__EC__PrivateKey_magic) : NULL;
	%:else
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_find(SvRV(ST(0)), PERL_MAGIC_ext) : NULL;
	%:endif
	if (magic)
		self = (Crypt__Bear__EC__PrivateKey)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::EC::PrivateKey object is lacking magic");
	}
;
#line 1539 "lib/Crypt/Bear.xs"
	RETVAL = self->curve;
#line 3176 "lib/Crypt/Bear.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    STMT_START {
		    union value value = { .integer = RETVAL };
		    const entry* entry = map_reverse_find(curves, value);
		    RETVALSV = entry ? newSVpvn(entry->key, entry->length) : newSV(0);
	    } STMT_END;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__EC__PrivateKey_generate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__EC__PrivateKey_generate)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "class, curve, prng");
    {
	Crypt__Bear__EC__PrivateKey	RETVAL;
	curve_type	curve = (map_get(curves, ST(1), "curve").integer)
;
	Crypt__Bear__PRNG	prng;

    {
		SV * sv = ST(2);
		if (SvROK(sv) && sv_derived_from(sv, "Crypt::Bear::PRNG"))
			prng = (Crypt__Bear__PRNG)SvPV_nolen(SvRV(sv));
		else
			croak("%s: %s is not of type %s", "Crypt::Bear::EC::PrivateKey::generate", "prng", "Crypt::Bear::PRNG");
    }
;
#line 1545 "lib/Crypt/Bear.xs"
	RETVAL = safemalloc(sizeof *RETVAL);
	size_t length = br_ec_keygen(prng, ec_default, RETVAL, NULL, curve);
	char* buffer = safemalloc(length);
	br_ec_keygen(prng, ec_default, RETVAL, buffer, curve);
#line 3217 "lib/Crypt/Bear.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    {
	    MAGIC* magic = sv_magicext(newSVrv(RETVALSV, "Crypt::Bear::EC::PrivateKey"), NULL, PERL_MAGIC_ext, &Crypt__Bear__EC__PrivateKey_magic, (const char*)RETVAL, 0);
	    magic->mg_flags |= MGf_COPY|MGf_DUP;
	    }
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__EC__PrivateKey_public_key); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__EC__PrivateKey_public_key)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Crypt__Bear__EC__PublicKey	RETVAL;
	Crypt__Bear__EC__PrivateKey	self;

	{
	%:ifdef mg_findext
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_findext(SvRV(ST(0)), PERL_MAGIC_ext, &Crypt__Bear__EC__PrivateKey_magic) : NULL;
	%:else
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_find(SvRV(ST(0)), PERL_MAGIC_ext) : NULL;
	%:endif
	if (magic)
		self = (Crypt__Bear__EC__PrivateKey)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::EC::PrivateKey object is lacking magic");
	}
;
#line 1554 "lib/Crypt/Bear.xs"
	RETVAL = safemalloc(sizeof *RETVAL);
	size_t length = br_ec_compute_pub(ec_default, RETVAL, NULL, self);
	char* buffer = safemalloc(length);
	br_ec_compute_pub(ec_default, RETVAL, buffer, self);
#line 3259 "lib/Crypt/Bear.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    {
	    MAGIC* magic = sv_magicext(newSVrv(RETVALSV, "Crypt::Bear::EC::PublicKey"), NULL, PERL_MAGIC_ext, &Crypt__Bear__EC__PublicKey_magic, (const char*)RETVAL, 0);
	    magic->mg_flags |= MGf_COPY|MGf_DUP;
	    }
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__EC__PrivateKey_ecdsa_sign); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__EC__PrivateKey_ecdsa_sign)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, hash_name, hash_value");
    {
	SV *	RETVAL;
	STRLEN	STRLEN_length_of_hash_value;
	size_t	XSauto_length_of_hash_value;
	Crypt__Bear__EC__PrivateKey	self;
	hash_type	hash_name = (map_get(hashs, ST(1), "hash").pointer)
;
	unsigned char *	hash_value = (unsigned char *)SvPV(ST(2), STRLEN_length_of_hash_value);

	XSauto_length_of_hash_value = STRLEN_length_of_hash_value;

	{
	%:ifdef mg_findext
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_findext(SvRV(ST(0)), PERL_MAGIC_ext, &Crypt__Bear__EC__PrivateKey_magic) : NULL;
	%:else
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_find(SvRV(ST(0)), PERL_MAGIC_ext) : NULL;
	%:endif
	if (magic)
		self = (Crypt__Bear__EC__PrivateKey)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::EC::PrivateKey object is lacking magic");
	}
;
#line 1563 "lib/Crypt/Bear.xs"
	size_t hash_size = ((hash_name->desc >> BR_HASHDESC_OUT_OFF) & BR_HASHDESC_OUT_MASK);
	if (STRLEN_length_of_hash_value != hash_size)
		Perl_croak(aTHX_ "Hash is inappropriately sized");
	RETVAL = make_buffer(ecdsa_max_size);
	size_t length = ec_sign_default(ec_default, hash_name, hash_value, self, SvPV_nolen(RETVAL));
	if (!length)
		Perl_croak(aTHX_ "Could not sign");
	SvCUR_set(RETVAL, length);
#line 3312 "lib/Crypt/Bear.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__EC__PrivateKey_ecdh_key_exchange); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__EC__PrivateKey_ecdh_key_exchange)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, other");
    {
	SV *	RETVAL;
	Crypt__Bear__EC__PrivateKey	self;
	Crypt__Bear__EC__PublicKey	other;

	{
	%:ifdef mg_findext
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_findext(SvRV(ST(0)), PERL_MAGIC_ext, &Crypt__Bear__EC__PrivateKey_magic) : NULL;
	%:else
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_find(SvRV(ST(0)), PERL_MAGIC_ext) : NULL;
	%:endif
	if (magic)
		self = (Crypt__Bear__EC__PrivateKey)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::EC::PrivateKey object is lacking magic");
	}
;

	{
	%:ifdef mg_findext
	MAGIC* magic = SvROK(ST(1)) && SvMAGICAL(SvRV(ST(1))) ? mg_findext(SvRV(ST(1)), PERL_MAGIC_ext, &Crypt__Bear__EC__PublicKey_magic) : NULL;
	%:else
	MAGIC* magic = SvROK(ST(1)) && SvMAGICAL(SvRV(ST(1))) ? mg_find(SvRV(ST(1)), PERL_MAGIC_ext) : NULL;
	%:endif
	if (magic)
		other = (Crypt__Bear__EC__PublicKey)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::EC::PublicKey object is lacking magic");
	}
;
#line 1576 "lib/Crypt/Bear.xs"
	if (self->curve != other->curve)
		Perl_croak(aTHX_ "Keys must be on same curve for EC key exchange");

	size_t out_length = 0;
	(ec_default->generator)(self->curve, &out_length);
	RETVAL = make_buffer(out_length);
	memcpy(SvPV_nolen(RETVAL), other->q, other->qlen);

	(ec_default->mul)(SvPV_nolen(RETVAL), other->qlen, self->x, self->xlen, self->curve);
	size_t xoff, xlen;
	xoff = ec_default->xoff(self->curve, &xlen);
	if (xoff)
		sv_chop(RETVAL, SvPV_nolen(RETVAL) + xoff);
	SvCUR_set(RETVAL, xlen);
#line 3371 "lib/Crypt/Bear.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__PEM_pem_encode); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__PEM_pem_encode)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "banner, data, ...");
    {
	SV *	RETVAL;
	STRLEN	STRLEN_length_of_data;
	size_t	XSauto_length_of_data;
	const char *	banner = (const char *)SvPV_nolen(ST(0))
;
	const char *	data = (const char *)SvPV(ST(1), STRLEN_length_of_data);

	XSauto_length_of_data = STRLEN_length_of_data;
#line 1597 "lib/Crypt/Bear.xs"
	unsigned flags = 0;
	for (int i = 3; i < items; i++) {
		flags |= lookup_pem_flag(ST(i));
	}
	size_t length = br_pem_encode(NULL, data, STRLEN_length_of_data, banner, flags);
	RETVAL = make_buffer(length);
	br_pem_encode(SvPV_nolen(RETVAL), data, STRLEN_length_of_data, banner, flags);
#line 3402 "lib/Crypt/Bear.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__PEM_pem_decode); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__PEM_pem_decode)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "data");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	RETVAL;
	STRLEN	STRLEN_length_of_data;
	size_t	XSauto_length_of_data;
	const char *	data = (const char *)SvPV(ST(0), STRLEN_length_of_data);

	XSauto_length_of_data = STRLEN_length_of_data;
#line 1610 "lib/Crypt/Bear.xs"
	pem_decoder decoder;
	br_pem_decoder_init(&decoder.decoder);
#ifdef MULTIPLICITY
	decoder.aTHX = aTHX;
#endif

	size_t left = STRLEN_length_of_data;
	while (left) {
		size_t pushed = br_pem_decoder_push(&decoder.decoder, data, left);
		data += pushed;
		left -= pushed;

		switch (br_pem_decoder_event(&decoder.decoder)) {
			case BR_PEM_BEGIN_OBJ: {
				decoder.name = newSVpv(br_pem_decoder_name(&decoder.decoder), 0);
				decoder.buffer = newSVpvn("", 0);
				br_pem_decoder_setdest(&decoder.decoder, pem_callback, &decoder);
				break;
			}
			case BR_PEM_END_OBJ: {
				if (decoder.buffer) {
					mXPUSHs(decoder.name);
					mXPUSHs(decoder.buffer);
					decoder.name = NULL;
					decoder.buffer = NULL;
				}
				break;
			}
			case BR_PEM_ERROR: {
				if (decoder.name)
					SvREFCNT_dec(decoder.name);
				if (decoder.buffer)
					SvREFCNT_dec(decoder.buffer);
				Perl_croak(aTHX_ "Could not parse PEM");
				break;
			}
		}
	}
#line 3464 "lib/Crypt/Bear.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Crypt__Bear__PEM__Decoder_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__PEM__Decoder_new)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "class, callback");
    {
	Crypt__Bear__PEM__Decoder	RETVAL;
	SV *	callback = ST(1)
;
#line 1653 "lib/Crypt/Bear.xs"
	RETVAL = safemalloc(sizeof *RETVAL);
	br_pem_decoder_init(&RETVAL->decoder);
	RETVAL->callback = SvREFCNT_inc(callback);
	RETVAL->name = NULL;
	RETVAL->buffer = NULL;
#ifdef MULTIPLICITY
	RETVAL->aTHX = aTHX;
#endif
#line 3490 "lib/Crypt/Bear.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    {
	    MAGIC* magic = sv_magicext(newSVrv(RETVALSV, "Crypt::Bear::PEM::Decoder"), NULL, PERL_MAGIC_ext, &Crypt__Bear__PEM__Decoder_magic, (const char*)RETVAL, 0);
	    magic->mg_flags |= MGf_COPY|MGf_DUP;
	    }
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__PEM__Decoder_push); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__PEM__Decoder_push)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, data");
    {
	STRLEN	STRLEN_length_of_data;
	size_t	XSauto_length_of_data;
	Crypt__Bear__PEM__Decoder	self;
	const char *	data = (const char *)SvPV(ST(1), STRLEN_length_of_data);

	XSauto_length_of_data = STRLEN_length_of_data;

	{
	%:ifdef mg_findext
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_findext(SvRV(ST(0)), PERL_MAGIC_ext, &Crypt__Bear__PEM__Decoder_magic) : NULL;
	%:else
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_find(SvRV(ST(0)), PERL_MAGIC_ext) : NULL;
	%:endif
	if (magic)
		self = (Crypt__Bear__PEM__Decoder)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::PEM::Decoder object is lacking magic");
	}
;
#line 1666 "lib/Crypt/Bear.xs"
	size_t left = STRLEN_length_of_data;
	while (left) {
		size_t pushed = br_pem_decoder_push(&self->decoder, data, left);
		data += pushed;
		left -= pushed;

		switch (br_pem_decoder_event(&self->decoder)) {
			case BR_PEM_BEGIN_OBJ: {
				self->name = newSVpv(br_pem_decoder_name(&self->decoder), 0);
				self->buffer = newSVpvn("", 0);
				br_pem_decoder_setdest(&self->decoder, pem_callback, self);
				break;
			}
			case BR_PEM_END_OBJ: {
				if (self->buffer) {
					ENTER;
					SAVETMPS;
					PUSHMARK(SP);
					mXPUSHs(self->name);
					mXPUSHs(self->buffer);
					PUTBACK;
					call_sv(self->callback, G_VOID | G_DISCARD);
					SPAGAIN;
					FREETMPS;
					LEAVE;
					self->name = NULL;
					self->buffer = NULL;
				}
				break;
			}
			case BR_PEM_ERROR: {
				if (self->buffer) {
					SvREFCNT_dec(self->buffer);
					self->buffer = NULL;
				}
				Perl_croak(aTHX_ "Could not parse PEM");
				break;
			}
		}
	}
#line 3572 "lib/Crypt/Bear.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__Bear__PEM__Decoder_entry_in_progress); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__PEM__Decoder_entry_in_progress)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	bool	RETVAL;
	Crypt__Bear__PEM__Decoder	self;

	{
	%:ifdef mg_findext
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_findext(SvRV(ST(0)), PERL_MAGIC_ext, &Crypt__Bear__PEM__Decoder_magic) : NULL;
	%:else
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_find(SvRV(ST(0)), PERL_MAGIC_ext) : NULL;
	%:endif
	if (magic)
		self = (Crypt__Bear__PEM__Decoder)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::PEM::Decoder object is lacking magic");
	}
;
#line 1709 "lib/Crypt/Bear.xs"
	RETVAL = self->buffer != NULL;
#line 3602 "lib/Crypt/Bear.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__X509__Certificate_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__X509__Certificate_new)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "class, data");
    {
	Crypt__Bear__X509__Certificate	RETVAL;
	STRLEN	STRLEN_length_of_data;
	size_t	XSauto_length_of_data;
	const unsigned char *	data = (const unsigned char *)SvPV(ST(1), STRLEN_length_of_data);

	XSauto_length_of_data = STRLEN_length_of_data;
#line 1717 "lib/Crypt/Bear.xs"
	RETVAL = safemalloc(sizeof(struct certificate));

	SV* dn = sv_2mortal(newSVpvn("", 0));
	struct decoder_helper helper = {
#ifdef MULTIPLICITY
		.aTHX = aTHX,
#endif
		.value = dn,
	};
	br_x509_decoder_init(&RETVAL->decoder, dn_decoder, &helper);
	br_x509_decoder_push(&RETVAL->decoder, data, STRLEN_length_of_data);

	br_error_type error = br_x509_decoder_last_error(&RETVAL->decoder);
	if (error != 0) {
		Safefree(RETVAL);
		Perl_croak(aTHX_ "Could not decode certificate: %s", lookup_error(error));
	}

	RETVAL->dn.data = (unsigned char*)savesvpv(dn);
	RETVAL->dn.len = SvCUR(dn);

	br_x509_certificate_init(&RETVAL->cert, data, STRLEN_length_of_data);
#line 3645 "lib/Crypt/Bear.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    {
	    MAGIC* magic = sv_magicext(newSVrv(RETVALSV, "Crypt::Bear::X509::Certificate"), NULL, PERL_MAGIC_ext, &Crypt__Bear__X509__Certificate_magic, (const char*)RETVAL, 0);
	    magic->mg_flags |= MGf_COPY|MGf_DUP;
	    }
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__X509__Certificate_dn); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__X509__Certificate_dn)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	RETVAL;
	Crypt__Bear__X509__Certificate	self;

	{
	%:ifdef mg_findext
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_findext(SvRV(ST(0)), PERL_MAGIC_ext, &Crypt__Bear__X509__Certificate_magic) : NULL;
	%:else
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_find(SvRV(ST(0)), PERL_MAGIC_ext) : NULL;
	%:endif
	if (magic)
		self = (Crypt__Bear__X509__Certificate)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::X509::Certificate object is lacking magic");
	}
;

	RETVAL = br_x509_certificate_dn(self);
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__X509__Certificate_public_key); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__X509__Certificate_public_key)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	RETVAL;
	Crypt__Bear__X509__Certificate	self;

	{
	%:ifdef mg_findext
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_findext(SvRV(ST(0)), PERL_MAGIC_ext, &Crypt__Bear__X509__Certificate_magic) : NULL;
	%:else
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_find(SvRV(ST(0)), PERL_MAGIC_ext) : NULL;
	%:endif
	if (magic)
		self = (Crypt__Bear__X509__Certificate)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::X509::Certificate object is lacking magic");
	}
;
#line 1746 "lib/Crypt/Bear.xs"
	br_x509_pkey* result = br_x509_decoder_get_pkey(&self->decoder);
	RETVAL = x509_key_unpack(result);
#line 3716 "lib/Crypt/Bear.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__X509__Certificate_is_ca); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__X509__Certificate_is_ca)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	bool	RETVAL;
	Crypt__Bear__X509__Certificate	self;

	{
	%:ifdef mg_findext
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_findext(SvRV(ST(0)), PERL_MAGIC_ext, &Crypt__Bear__X509__Certificate_magic) : NULL;
	%:else
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_find(SvRV(ST(0)), PERL_MAGIC_ext) : NULL;
	%:endif
	if (magic)
		self = (Crypt__Bear__X509__Certificate)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::X509::Certificate object is lacking magic");
	}
;

	RETVAL = br_x509_certificate_is_ca(self);
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__X509__Certificate_signer_key_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__X509__Certificate_signer_key_type)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	key_kind_type	RETVAL;
	Crypt__Bear__X509__Certificate	self;

	{
	%:ifdef mg_findext
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_findext(SvRV(ST(0)), PERL_MAGIC_ext, &Crypt__Bear__X509__Certificate_magic) : NULL;
	%:else
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_find(SvRV(ST(0)), PERL_MAGIC_ext) : NULL;
	%:endif
	if (magic)
		self = (Crypt__Bear__X509__Certificate)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::X509::Certificate object is lacking magic");
	}
;

	RETVAL = br_x509_certificate_signer_key_type(self);
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    STMT_START {
		    union value value = { .integer = RETVAL };
		    const entry* entry = map_reverse_find(key_kinds, value);
		    RETVALSV = entry ? newSVpvn(entry->key, entry->length) : newSV(0);
	    } STMT_END;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__X509__PrivateKey_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__X509__PrivateKey_new)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "class, data");
    {
	Crypt__Bear__X509__PrivateKey	RETVAL;
	STRLEN	STRLEN_length_of_data;
	size_t	XSauto_length_of_data;
	const char *	data = (const char *)SvPV(ST(1), STRLEN_length_of_data);

	XSauto_length_of_data = STRLEN_length_of_data;
#line 1761 "lib/Crypt/Bear.xs"
	br_skey_decoder_context context;
	br_skey_decoder_init(&context);
	br_skey_decoder_push(&context, data, STRLEN_length_of_data);

	br_error_type error = br_skey_decoder_last_error(&context);
	if (error != 0)
		Perl_croak(aTHX_ "Could not decode private key: %s", lookup_error(error));

	RETVAL = safemalloc(sizeof *RETVAL);

	RETVAL->key_type = br_skey_decoder_key_type(&context);
	if (RETVAL->key_type == BR_KEYTYPE_RSA) {
		rsa_private_key_copy(&RETVAL->rsa, br_skey_decoder_get_rsa(&context));
	} else if (RETVAL->key_type == BR_KEYTYPE_EC) {
		ec_private_key_copy(&RETVAL->ec, br_skey_decoder_get_ec(&context));
	}
#line 3823 "lib/Crypt/Bear.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    {
	    MAGIC* magic = sv_magicext(newSVrv(RETVALSV, "Crypt::Bear::X509::PrivateKey"), NULL, PERL_MAGIC_ext, &Crypt__Bear__X509__PrivateKey_magic, (const char*)RETVAL, 0);
	    magic->mg_flags |= MGf_COPY|MGf_DUP;
	    }
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__X509__PrivateKey_unpack); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__X509__PrivateKey_unpack)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	RETVAL;
	Crypt__Bear__X509__PrivateKey	self;

	{
	%:ifdef mg_findext
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_findext(SvRV(ST(0)), PERL_MAGIC_ext, &Crypt__Bear__X509__PrivateKey_magic) : NULL;
	%:else
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_find(SvRV(ST(0)), PERL_MAGIC_ext) : NULL;
	%:endif
	if (magic)
		self = (Crypt__Bear__X509__PrivateKey)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::X509::PrivateKey object is lacking magic");
	}
;
#line 1783 "lib/Crypt/Bear.xs"
	RETVAL = &PL_sv_undef;
	if (self->key_type == BR_KEYTYPE_RSA) {
		br_rsa_private_key* key = safemalloc(sizeof *key);
		rsa_private_key_copy(key, &self->rsa);
		RETVAL = make_magic(key, "Crypt::Bear::RSA::PrivateKey", &Crypt__Bear__RSA__PrivateKey_magic);
	} else if (self->key_type == BR_KEYTYPE_EC) {
		br_ec_private_key* key = safemalloc(sizeof *key);
		ec_private_key_copy(key, &self->ec);
		RETVAL = make_magic(key, "Crypt::Bear::EC::PrivateKey", &Crypt__Bear__EC__PrivateKey_magic);
	}
#line 3871 "lib/Crypt/Bear.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__X509__PrivateKey_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__X509__PrivateKey_type)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	key_kind_type	RETVAL;
	Crypt__Bear__X509__PrivateKey	self;

	{
	%:ifdef mg_findext
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_findext(SvRV(ST(0)), PERL_MAGIC_ext, &Crypt__Bear__X509__PrivateKey_magic) : NULL;
	%:else
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_find(SvRV(ST(0)), PERL_MAGIC_ext) : NULL;
	%:endif
	if (magic)
		self = (Crypt__Bear__X509__PrivateKey)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::X509::PrivateKey object is lacking magic");
	}
;
#line 1799 "lib/Crypt/Bear.xs"
	RETVAL = self->key_type;
#line 3903 "lib/Crypt/Bear.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    STMT_START {
		    union value value = { .integer = RETVAL };
		    const entry* entry = map_reverse_find(key_kinds, value);
		    RETVALSV = entry ? newSVpvn(entry->key, entry->length) : newSV(0);
	    } STMT_END;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__X509__TrustAnchors_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__X509__TrustAnchors_new)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "class");
    {
	Crypt__Bear__X509__TrustAnchors	RETVAL;
#line 1809 "lib/Crypt/Bear.xs"
	RETVAL = safemalloc(sizeof *RETVAL);
	trust_anchors_init(RETVAL);
#line 3930 "lib/Crypt/Bear.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    {
	    MAGIC* magic = sv_magicext(newSVrv(RETVALSV, "Crypt::Bear::X509::TrustAnchors"), NULL, PERL_MAGIC_ext, &Crypt__Bear__X509__TrustAnchors_magic, (const char*)RETVAL, 0);
	    magic->mg_flags |= MGf_COPY|MGf_DUP;
	    }
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__X509__TrustAnchors_add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__X509__TrustAnchors_add)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "self, certificate, is_ca= br_x509_decoder_isCA(&certificate->decoder)");
    {
	Crypt__Bear__X509__TrustAnchors	self;
	Crypt__Bear__X509__Certificate	certificate;
	bool	is_ca;

	{
	%:ifdef mg_findext
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_findext(SvRV(ST(0)), PERL_MAGIC_ext, &Crypt__Bear__X509__TrustAnchors_magic) : NULL;
	%:else
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_find(SvRV(ST(0)), PERL_MAGIC_ext) : NULL;
	%:endif
	if (magic)
		self = (Crypt__Bear__X509__TrustAnchors)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::X509::TrustAnchors object is lacking magic");
	}
;

	{
	%:ifdef mg_findext
	MAGIC* magic = SvROK(ST(1)) && SvMAGICAL(SvRV(ST(1))) ? mg_findext(SvRV(ST(1)), PERL_MAGIC_ext, &Crypt__Bear__X509__Certificate_magic) : NULL;
	%:else
	MAGIC* magic = SvROK(ST(1)) && SvMAGICAL(SvRV(ST(1))) ? mg_find(SvRV(ST(1)), PERL_MAGIC_ext) : NULL;
	%:endif
	if (magic)
		certificate = (Crypt__Bear__X509__Certificate)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::X509::Certificate object is lacking magic");
	}
;

	if (items < 3)
	    is_ca = br_x509_decoder_isCA(&certificate->decoder);
	else {
	    is_ca = (bool)SvTRUE(ST(2))
;
	}
#line 1816 "lib/Crypt/Bear.xs"
	br_x509_trust_anchor anchor = { .flags = is_ca ? BR_X509_TA_CA : 0};
	dn_copy(&anchor.dn, &certificate->dn);
	x509_key_copy(&anchor.pkey, br_x509_decoder_get_pkey(&certificate->decoder));
	trust_anchors_push(self, &anchor);
#line 3993 "lib/Crypt/Bear.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__Bear__X509__TrustAnchors_merge); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__X509__TrustAnchors_merge)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, other");
    {
	Crypt__Bear__X509__TrustAnchors	self;
	Crypt__Bear__X509__TrustAnchors	other;

	{
	%:ifdef mg_findext
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_findext(SvRV(ST(0)), PERL_MAGIC_ext, &Crypt__Bear__X509__TrustAnchors_magic) : NULL;
	%:else
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_find(SvRV(ST(0)), PERL_MAGIC_ext) : NULL;
	%:endif
	if (magic)
		self = (Crypt__Bear__X509__TrustAnchors)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::X509::TrustAnchors object is lacking magic");
	}
;

	{
	%:ifdef mg_findext
	MAGIC* magic = SvROK(ST(1)) && SvMAGICAL(SvRV(ST(1))) ? mg_findext(SvRV(ST(1)), PERL_MAGIC_ext, &Crypt__Bear__X509__TrustAnchors_magic) : NULL;
	%:else
	MAGIC* magic = SvROK(ST(1)) && SvMAGICAL(SvRV(ST(1))) ? mg_find(SvRV(ST(1)), PERL_MAGIC_ext) : NULL;
	%:endif
	if (magic)
		other = (Crypt__Bear__X509__TrustAnchors)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::X509::TrustAnchors object is lacking magic");
	}
;
#line 1823 "lib/Crypt/Bear.xs"
	for (size_t i = 0; i < other->used; i++) {
		const br_x509_trust_anchor* old = other->array + i;
		br_x509_trust_anchor anchor = { .flags = old->flags };
		dn_copy(&anchor.dn, &old->dn);
		x509_key_copy(&anchor.pkey, &old->pkey);
		trust_anchors_push(self, &anchor);
	}
#line 4042 "lib/Crypt/Bear.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__Bear__X509__TrustAnchors_names); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__X509__TrustAnchors_names)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Crypt__Bear__X509__TrustAnchors	self;

	{
	%:ifdef mg_findext
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_findext(SvRV(ST(0)), PERL_MAGIC_ext, &Crypt__Bear__X509__TrustAnchors_magic) : NULL;
	%:else
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_find(SvRV(ST(0)), PERL_MAGIC_ext) : NULL;
	%:endif
	if (magic)
		self = (Crypt__Bear__X509__TrustAnchors)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::X509::TrustAnchors object is lacking magic");
	}
;
#line 1833 "lib/Crypt/Bear.xs"
	for (size_t i = 0; i < self->used; i++) {
		const br_x509_trust_anchor* anchor = self->array + i;
		mXPUSHp((const char*)anchor->dn.data, anchor->dn.len);
	}
#line 4076 "lib/Crypt/Bear.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Crypt__Bear__X509__TrustAnchors_count); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__X509__TrustAnchors_count)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	UV	RETVAL;
	dXSTARG;
	Crypt__Bear__X509__TrustAnchors	self;

	{
	%:ifdef mg_findext
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_findext(SvRV(ST(0)), PERL_MAGIC_ext, &Crypt__Bear__X509__TrustAnchors_magic) : NULL;
	%:else
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_find(SvRV(ST(0)), PERL_MAGIC_ext) : NULL;
	%:endif
	if (magic)
		self = (Crypt__Bear__X509__TrustAnchors)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::X509::TrustAnchors object is lacking magic");
	}
;
#line 1840 "lib/Crypt/Bear.xs"
	RETVAL = self->used;
#line 4108 "lib/Crypt/Bear.c"
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__X509__Validator_start_chain); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__X509__Validator_start_chain)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, server_name");
    {
	Crypt__Bear__X509__Validator	self;
	const char *	server_name = (const char *)SvPV_nolen(ST(1))
;

	{
	%:ifdef mg_findext
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_findext(SvRV(ST(0)), PERL_MAGIC_ext, NULL) : NULL;
	%:else
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_find(SvRV(ST(0)), PERL_MAGIC_ext) : NULL;
	%:endif
	if (magic)
		self = (Crypt__Bear__X509__Validator)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::X509::Validator object is lacking magic");
	}
;
#line 1848 "lib/Crypt/Bear.xs"
	((*self)->start_chain)(self, server_name);
#line 4141 "lib/Crypt/Bear.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__Bear__X509__Validator_start_certificate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__X509__Validator_start_certificate)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, length");
    {
	Crypt__Bear__X509__Validator	self;
	size_t	length = (size_t)SvUV(ST(1))
;

	{
	%:ifdef mg_findext
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_findext(SvRV(ST(0)), PERL_MAGIC_ext, NULL) : NULL;
	%:else
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_find(SvRV(ST(0)), PERL_MAGIC_ext) : NULL;
	%:endif
	if (magic)
		self = (Crypt__Bear__X509__Validator)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::X509::Validator object is lacking magic");
	}
;
#line 1852 "lib/Crypt/Bear.xs"
	((*self)->start_cert)(self, length);
#line 4172 "lib/Crypt/Bear.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__Bear__X509__Validator_append); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__X509__Validator_append)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, data");
    {
	STRLEN	STRLEN_length_of_data;
	size_t	XSauto_length_of_data;
	Crypt__Bear__X509__Validator	self;
	const unsigned char *	data = (const unsigned char *)SvPV(ST(1), STRLEN_length_of_data);

	XSauto_length_of_data = STRLEN_length_of_data;

	{
	%:ifdef mg_findext
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_findext(SvRV(ST(0)), PERL_MAGIC_ext, NULL) : NULL;
	%:else
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_find(SvRV(ST(0)), PERL_MAGIC_ext) : NULL;
	%:endif
	if (magic)
		self = (Crypt__Bear__X509__Validator)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::X509::Validator object is lacking magic");
	}
;
#line 1856 "lib/Crypt/Bear.xs"
	((*self)->append)(self, data, STRLEN_length_of_data);
#line 4206 "lib/Crypt/Bear.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__Bear__X509__Validator_end_certificate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__X509__Validator_end_certificate)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Crypt__Bear__X509__Validator	self;

	{
	%:ifdef mg_findext
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_findext(SvRV(ST(0)), PERL_MAGIC_ext, NULL) : NULL;
	%:else
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_find(SvRV(ST(0)), PERL_MAGIC_ext) : NULL;
	%:endif
	if (magic)
		self = (Crypt__Bear__X509__Validator)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::X509::Validator object is lacking magic");
	}
;
#line 1860 "lib/Crypt/Bear.xs"
	((*self)->end_cert)(self);
#line 4235 "lib/Crypt/Bear.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__Bear__X509__Validator_end_chain); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__X509__Validator_end_chain)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Crypt__Bear__X509__Validator	self;

	{
	%:ifdef mg_findext
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_findext(SvRV(ST(0)), PERL_MAGIC_ext, NULL) : NULL;
	%:else
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_find(SvRV(ST(0)), PERL_MAGIC_ext) : NULL;
	%:endif
	if (magic)
		self = (Crypt__Bear__X509__Validator)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::X509::Validator object is lacking magic");
	}
;
#line 1864 "lib/Crypt/Bear.xs"
	((*self)->end_chain)(self);
#line 4264 "lib/Crypt/Bear.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__Bear__X509__Validator_get_pkey); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__X509__Validator_get_pkey)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, wanted_usage");
    {
	SV *	RETVAL;
	Crypt__Bear__X509__Validator	self;
	unsigned	wanted_usage = (unsigned)SvUV(ST(1))
;

	{
	%:ifdef mg_findext
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_findext(SvRV(ST(0)), PERL_MAGIC_ext, NULL) : NULL;
	%:else
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_find(SvRV(ST(0)), PERL_MAGIC_ext) : NULL;
	%:endif
	if (magic)
		self = (Crypt__Bear__X509__Validator)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::X509::Validator object is lacking magic");
	}
;
#line 1868 "lib/Crypt/Bear.xs"
	unsigned usage;
	const br_x509_pkey* public_key = ((*self)->get_pkey)(self, &usage);

	if (wanted_usage && (usage & wanted_usage) != wanted_usage)
		RETVAL = &PL_sv_undef;
	else if (public_key)
		RETVAL = x509_key_unpack(public_key);
	else
		RETVAL = &PL_sv_undef;
#line 4304 "lib/Crypt/Bear.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__X509__Validator__Minimal_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__X509__Validator__Minimal_new)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "class, anchors");
    {
	Crypt__Bear__X509__Validator__Minimal	RETVAL;
	SV *	class = ST(0)
;
	Crypt__Bear__X509__TrustAnchors	anchors;

	{
	%:ifdef mg_findext
	MAGIC* magic = SvROK(ST(1)) && SvMAGICAL(SvRV(ST(1))) ? mg_findext(SvRV(ST(1)), PERL_MAGIC_ext, &Crypt__Bear__X509__TrustAnchors_magic) : NULL;
	%:else
	MAGIC* magic = SvROK(ST(1)) && SvMAGICAL(SvRV(ST(1))) ? mg_find(SvRV(ST(1)), PERL_MAGIC_ext) : NULL;
	%:endif
	if (magic)
		anchors = (Crypt__Bear__X509__TrustAnchors)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::X509::TrustAnchors object is lacking magic");
	}
;
#line 1886 "lib/Crypt/Bear.xs"
	RETVAL = safemalloc(sizeof *RETVAL);
	trust_anchors_copy(&RETVAL->anchors, anchors);
	br_x509_minimal_init_full(&RETVAL->context, RETVAL->anchors.array, RETVAL->anchors.used);
#line 4340 "lib/Crypt/Bear.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_magic(newSVrv(RETVALSV, "Crypt::Bear::X509::Validator::Minimal"), NULL, PERL_MAGIC_ext, (const char*)RETVAL, 0);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#if 0
#define XSubPPtmpAAAB 1


XS_EUPXS(XS_Crypt__Bear__X509__Validator__Minimal_set_time); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__X509__Validator__Minimal_set_time)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, days, seconds");
    {
	Crypt__Bear__X509__Validator__Minimal	self;
	UV	days = (UV)SvUV(ST(1))
;
	UV	seconds = (UV)SvUV(ST(2))
;

	{
	%:ifdef mg_findext
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_findext(SvRV(ST(0)), PERL_MAGIC_ext, NULL) : NULL;
	%:else
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_find(SvRV(ST(0)), PERL_MAGIC_ext) : NULL;
	%:endif
	if (magic)
		self = (Crypt__Bear__X509__Validator__Minimal)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::X509::Validator::Minimal object is lacking magic");
	}
;

	br_x509_minimal_set_time(self, days, seconds);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__Bear__X509__Validator__Minimal_set_minrsa); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__X509__Validator__Minimal_set_minrsa)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, size");
    {
	Crypt__Bear__X509__Validator__Minimal	self;
	UV	size = (UV)SvUV(ST(1))
;

	{
	%:ifdef mg_findext
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_findext(SvRV(ST(0)), PERL_MAGIC_ext, NULL) : NULL;
	%:else
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_find(SvRV(ST(0)), PERL_MAGIC_ext) : NULL;
	%:endif
	if (magic)
		self = (Crypt__Bear__X509__Validator__Minimal)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::X509::Validator::Minimal object is lacking magic");
	}
;

	br_x509_minimal_set_minrsa(self, size);
    }
    XSRETURN_EMPTY;
}

#endif

XS_EUPXS(XS_Crypt__Bear__X509__Certificate__Chain_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__X509__Certificate__Chain_new)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "class");
    {
	Crypt__Bear__X509__Certificate__Chain	RETVAL;
#line 1917 "lib/Crypt/Bear.xs"
	RETVAL = safemalloc(sizeof *RETVAL);
	certificate_chain_init(RETVAL);
#line 4429 "lib/Crypt/Bear.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    {
	    MAGIC* magic = sv_magicext(newSVrv(RETVALSV, "Crypt::Bear::X509::Certificate::Chain"), NULL, PERL_MAGIC_ext, &Crypt__Bear__X509__Certificate__Chain_magic, (const char*)RETVAL, 0);
	    magic->mg_flags |= MGf_COPY|MGf_DUP;
	    }
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__X509__Certificate__Chain_add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__X509__Certificate__Chain_add)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, certificate");
    {
	Crypt__Bear__X509__Certificate__Chain	self;
	Crypt__Bear__X509__Certificate	certificate;

	{
	%:ifdef mg_findext
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_findext(SvRV(ST(0)), PERL_MAGIC_ext, &Crypt__Bear__X509__Certificate__Chain_magic) : NULL;
	%:else
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_find(SvRV(ST(0)), PERL_MAGIC_ext) : NULL;
	%:endif
	if (magic)
		self = (Crypt__Bear__X509__Certificate__Chain)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::X509::Certificate::Chain object is lacking magic");
	}
;

	{
	%:ifdef mg_findext
	MAGIC* magic = SvROK(ST(1)) && SvMAGICAL(SvRV(ST(1))) ? mg_findext(SvRV(ST(1)), PERL_MAGIC_ext, &Crypt__Bear__X509__Certificate_magic) : NULL;
	%:else
	MAGIC* magic = SvROK(ST(1)) && SvMAGICAL(SvRV(ST(1))) ? mg_find(SvRV(ST(1)), PERL_MAGIC_ext) : NULL;
	%:endif
	if (magic)
		certificate = (Crypt__Bear__X509__Certificate)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::X509::Certificate object is lacking magic");
	}
;
#line 1924 "lib/Crypt/Bear.xs"
	br_x509_certificate entry;
	br_x509_certificate_copy(&entry, &certificate->cert);
	certificate_chain_push(self, &entry);
	if (self->used == 1)
		self->signer_key_type = br_x509_decoder_get_signer_key_type(&certificate->decoder);
#line 4485 "lib/Crypt/Bear.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__Bear__X509__Certificate__Chain_count); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__X509__Certificate__Chain_count)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	UV	RETVAL;
	dXSTARG;
	Crypt__Bear__X509__Certificate__Chain	self;

	{
	%:ifdef mg_findext
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_findext(SvRV(ST(0)), PERL_MAGIC_ext, &Crypt__Bear__X509__Certificate__Chain_magic) : NULL;
	%:else
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_find(SvRV(ST(0)), PERL_MAGIC_ext) : NULL;
	%:endif
	if (magic)
		self = (Crypt__Bear__X509__Certificate__Chain)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::X509::Certificate::Chain object is lacking magic");
	}
;
#line 1933 "lib/Crypt/Bear.xs"
	RETVAL = self->used;
#line 4516 "lib/Crypt/Bear.c"
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__SSL__PrivateCertificate_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__SSL__PrivateCertificate_new)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "class, certs, key, usage= automatic");
    {
	Crypt__Bear__SSL__PrivateCertificate	RETVAL;
	Crypt__Bear__X509__Certificate__Chain	certs;
	Crypt__Bear__X509__PrivateKey	key;
	usage_type	usage;

	{
	%:ifdef mg_findext
	MAGIC* magic = SvROK(ST(1)) && SvMAGICAL(SvRV(ST(1))) ? mg_findext(SvRV(ST(1)), PERL_MAGIC_ext, &Crypt__Bear__X509__Certificate__Chain_magic) : NULL;
	%:else
	MAGIC* magic = SvROK(ST(1)) && SvMAGICAL(SvRV(ST(1))) ? mg_find(SvRV(ST(1)), PERL_MAGIC_ext) : NULL;
	%:endif
	if (magic)
		certs = (Crypt__Bear__X509__Certificate__Chain)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::X509::Certificate::Chain object is lacking magic");
	}
;

	{
	%:ifdef mg_findext
	MAGIC* magic = SvROK(ST(2)) && SvMAGICAL(SvRV(ST(2))) ? mg_findext(SvRV(ST(2)), PERL_MAGIC_ext, &Crypt__Bear__X509__PrivateKey_magic) : NULL;
	%:else
	MAGIC* magic = SvROK(ST(2)) && SvMAGICAL(SvRV(ST(2))) ? mg_find(SvRV(ST(2)), PERL_MAGIC_ext) : NULL;
	%:endif
	if (magic)
		key = (Crypt__Bear__X509__PrivateKey)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::X509::PrivateKey object is lacking magic");
	}
;

	if (items < 4)
	    usage = automatic;
	else {
	    usage = (map_get(usages, ST(3), "usage").integer)
;
	}
#line 1943 "lib/Crypt/Bear.xs"
	RETVAL = safemalloc(sizeof *RETVAL);
	certificate_chain_copy(&RETVAL->chain, certs);
	private_key_copy(&RETVAL->key, key);
	RETVAL->usage = usage;
#line 4573 "lib/Crypt/Bear.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    {
	    MAGIC* magic = sv_magicext(newSVrv(RETVALSV, "Crypt::Bear::SSL::PrivateCertificate"), NULL, PERL_MAGIC_ext, &Crypt__Bear__SSL__PrivateCertificate_magic, (const char*)RETVAL, 0);
	    magic->mg_flags |= MGf_COPY|MGf_DUP;
	    }
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__SSL__PrivateCertificate_chain); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__SSL__PrivateCertificate_chain)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Crypt__Bear__X509__Certificate__Chain	RETVAL;
	Crypt__Bear__SSL__PrivateCertificate	self;

	{
	%:ifdef mg_findext
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_findext(SvRV(ST(0)), PERL_MAGIC_ext, &Crypt__Bear__SSL__PrivateCertificate_magic) : NULL;
	%:else
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_find(SvRV(ST(0)), PERL_MAGIC_ext) : NULL;
	%:endif
	if (magic)
		self = (Crypt__Bear__SSL__PrivateCertificate)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::SSL::PrivateCertificate object is lacking magic");
	}
;
#line 1952 "lib/Crypt/Bear.xs"
	RETVAL = safemalloc(sizeof *RETVAL);
	certificate_chain_copy(RETVAL, &self->chain);
#line 4613 "lib/Crypt/Bear.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    {
	    MAGIC* magic = sv_magicext(newSVrv(RETVALSV, "Crypt::Bear::X509::Certificate::Chain"), NULL, PERL_MAGIC_ext, &Crypt__Bear__X509__Certificate__Chain_magic, (const char*)RETVAL, 0);
	    magic->mg_flags |= MGf_COPY|MGf_DUP;
	    }
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__SSL__PrivateCertificate_key); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__SSL__PrivateCertificate_key)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Crypt__Bear__X509__PrivateKey	RETVAL;
	Crypt__Bear__SSL__PrivateCertificate	self;

	{
	%:ifdef mg_findext
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_findext(SvRV(ST(0)), PERL_MAGIC_ext, &Crypt__Bear__SSL__PrivateCertificate_magic) : NULL;
	%:else
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_find(SvRV(ST(0)), PERL_MAGIC_ext) : NULL;
	%:endif
	if (magic)
		self = (Crypt__Bear__SSL__PrivateCertificate)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::SSL::PrivateCertificate object is lacking magic");
	}
;
#line 1959 "lib/Crypt/Bear.xs"
	RETVAL = safemalloc(sizeof *RETVAL);
	private_key_copy(RETVAL, &self->key);
#line 4653 "lib/Crypt/Bear.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    {
	    MAGIC* magic = sv_magicext(newSVrv(RETVALSV, "Crypt::Bear::X509::PrivateKey"), NULL, PERL_MAGIC_ext, &Crypt__Bear__X509__PrivateKey_magic, (const char*)RETVAL, 0);
	    magic->mg_flags |= MGf_COPY|MGf_DUP;
	    }
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__SSL__Engine_get_server_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__SSL__Engine_get_server_name)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	const char *	RETVAL;
	dXSTARG;
	Crypt__Bear__SSL__Engine	self;

	{
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_find(SvRV(ST(0)), PERL_MAGIC_ext) : NULL;
	if (magic && magic->mg_virtual)
		self = (Crypt__Bear__SSL__Engine)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::SSL::Engine object is lacking magic");
	}
;

	RETVAL = br_ssl_engine_get_server_name(self);
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__SSL__Engine_get_version); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__SSL__Engine_get_version)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	ssl_version_type	RETVAL;
	Crypt__Bear__SSL__Engine	self;

	{
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_find(SvRV(ST(0)), PERL_MAGIC_ext) : NULL;
	if (magic && magic->mg_virtual)
		self = (Crypt__Bear__SSL__Engine)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::SSL::Engine object is lacking magic");
	}
;

	RETVAL = br_ssl_engine_get_version(self);
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    STMT_START {
		    union value value = { .integer = RETVAL };
		    const entry* entry = map_reverse_find(ssl_versions, value);
		    RETVALSV = entry ? newSVpvn(entry->key, entry->length) : newSV(0);
	    } STMT_END;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__SSL__Engine_set_versions); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__SSL__Engine_set_versions)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, min, max");
    {
	Crypt__Bear__SSL__Engine	self;
	ssl_version_type	min = (map_get(ssl_versions, ST(1), "ssl_version").integer)
;
	ssl_version_type	max = (map_get(ssl_versions, ST(2), "ssl_version").integer)
;

	{
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_find(SvRV(ST(0)), PERL_MAGIC_ext) : NULL;
	if (magic && magic->mg_virtual)
		self = (Crypt__Bear__SSL__Engine)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::SSL::Engine object is lacking magic");
	}
;

	br_ssl_engine_set_versions(self, min, max);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__Bear__SSL__Engine_get_ecdhe_curve); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__SSL__Engine_get_ecdhe_curve)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	curve_type	RETVAL;
	Crypt__Bear__SSL__Engine	self;

	{
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_find(SvRV(ST(0)), PERL_MAGIC_ext) : NULL;
	if (magic && magic->mg_virtual)
		self = (Crypt__Bear__SSL__Engine)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::SSL::Engine object is lacking magic");
	}
;

	RETVAL = br_ssl_engine_get_ecdhe_curve(self);
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    STMT_START {
		    union value value = { .integer = RETVAL };
		    const entry* entry = map_reverse_find(curves, value);
		    RETVALSV = entry ? newSVpvn(entry->key, entry->length) : newSV(0);
	    } STMT_END;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__SSL__Engine_last_error); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__SSL__Engine_last_error)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	br_error_type	RETVAL;
	Crypt__Bear__SSL__Engine	self;

	{
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_find(SvRV(ST(0)), PERL_MAGIC_ext) : NULL;
	if (magic && magic->mg_virtual)
		self = (Crypt__Bear__SSL__Engine)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::SSL::Engine object is lacking magic");
	}
;

	RETVAL = br_ssl_engine_last_error(self);
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    STMT_START {
		    union value value = { .integer = RETVAL };
		    const entry* entry = map_reverse_find(br_errors, value);
		    RETVALSV = entry ? newSVpvn(entry->key, entry->length) : newSV(0);
	    } STMT_END;
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__SSL__Engine_inject_entropy); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__SSL__Engine_inject_entropy)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, data");
    {
	STRLEN	STRLEN_length_of_data;
	size_t	XSauto_length_of_data;
	Crypt__Bear__SSL__Engine	self;
	const char *	data = (const char *)SvPV(ST(1), STRLEN_length_of_data);

	XSauto_length_of_data = STRLEN_length_of_data;

	{
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_find(SvRV(ST(0)), PERL_MAGIC_ext) : NULL;
	if (magic && magic->mg_virtual)
		self = (Crypt__Bear__SSL__Engine)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::SSL::Engine object is lacking magic");
	}
;

	br_ssl_engine_inject_entropy(self, data, XSauto_length_of_data);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__Bear__SSL__Engine_get_session_parameters); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__SSL__Engine_get_session_parameters)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Crypt__Bear__SSL__Session	RETVAL;
	Crypt__Bear__SSL__Engine	self;

	{
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_find(SvRV(ST(0)), PERL_MAGIC_ext) : NULL;
	if (magic && magic->mg_virtual)
		self = (Crypt__Bear__SSL__Engine)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::SSL::Engine object is lacking magic");
	}
;
#line 1981 "lib/Crypt/Bear.xs"
	RETVAL = safemalloc(sizeof *RETVAL);
	br_ssl_engine_get_session_parameters(self, RETVAL);
#line 4880 "lib/Crypt/Bear.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    {
		    sv_setref_pvn(RETVALSV, "Crypt::Bear::SSL::Session", (const char*)RETVAL, sizeof(*RETVAL));
		    SvREADONLY_on(SvRV(RETVALSV));
	    }
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__SSL__Engine_set_session_parameters); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__SSL__Engine_set_session_parameters)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, pp");
    {
	Crypt__Bear__SSL__Engine	self;
	Crypt__Bear__SSL__Session	pp;

	{
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_find(SvRV(ST(0)), PERL_MAGIC_ext) : NULL;
	if (magic && magic->mg_virtual)
		self = (Crypt__Bear__SSL__Engine)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::SSL::Engine object is lacking magic");
	}
;

    {
		SV * sv = ST(1);
		if (SvROK(sv) && sv_derived_from(sv, "Crypt::Bear::SSL::Session"))
			pp = (Crypt__Bear__SSL__Session)SvPV_nolen(SvRV(sv));
		else
			croak("%s: %s is not of type %s", "Crypt::Bear::SSL::Engine::set_session_parameters", "pp", "Crypt::Bear::SSL::Session");
    }
;

	br_ssl_engine_set_session_parameters(self, pp);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__Bear__SSL__Engine_is_closed); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__SSL__Engine_is_closed)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	bool	RETVAL;
	Crypt__Bear__SSL__Engine	self;

	{
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_find(SvRV(ST(0)), PERL_MAGIC_ext) : NULL;
	if (magic && magic->mg_virtual)
		self = (Crypt__Bear__SSL__Engine)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::SSL::Engine object is lacking magic");
	}
;
#line 1990 "lib/Crypt/Bear.xs"
	RETVAL = br_ssl_engine_current_state(self) == BR_SSL_CLOSED;
#line 4949 "lib/Crypt/Bear.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__SSL__Engine_send_ready); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__SSL__Engine_send_ready)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	bool	RETVAL;
	Crypt__Bear__SSL__Engine	self;

	{
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_find(SvRV(ST(0)), PERL_MAGIC_ext) : NULL;
	if (magic && magic->mg_virtual)
		self = (Crypt__Bear__SSL__Engine)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::SSL::Engine object is lacking magic");
	}
;
#line 1996 "lib/Crypt/Bear.xs"
	RETVAL = cBOOL(br_ssl_engine_current_state(self) & BR_SSL_SENDAPP);
#line 4976 "lib/Crypt/Bear.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__SSL__Engine_push_received); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__SSL__Engine_push_received)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, data");
    {
	SV *	RETVAL;
	STRLEN	STRLEN_length_of_data;
	size_t	XSauto_length_of_data;
	Crypt__Bear__SSL__Engine	self;
	unsigned char *	data = (unsigned char *)SvPV(ST(1), STRLEN_length_of_data);

	XSauto_length_of_data = STRLEN_length_of_data;

	{
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_find(SvRV(ST(0)), PERL_MAGIC_ext) : NULL;
	if (magic && magic->mg_virtual)
		self = (Crypt__Bear__SSL__Engine)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::SSL::Engine object is lacking magic");
	}
;
#line 2002 "lib/Crypt/Bear.xs"
	RETVAL = newSVpvn("", 0);
	size_t offset = 0;

	while (br_ssl_engine_current_state(self) & BR_SSL_RECVAPP) {
		size_t len = 0;
		unsigned char* buffer = br_ssl_engine_recvapp_buf(self, &len);

		sv_catpvn(RETVAL, (const char*)buffer, len);
		br_ssl_engine_recvapp_ack(self, len);
	}

	do {
		if (br_ssl_engine_current_state(self) == BR_SSL_CLOSED)
			Perl_croak(aTHX_ "Connection is closed");

		size_t len = 0;
		unsigned char* buffer = br_ssl_engine_recvrec_buf(self, &len);

		if (len) {
			size_t available = STRLEN_length_of_data - offset;

			if (len > available)
				len = available;

			memcpy(buffer, data + offset, len);
			offset += len;
			br_ssl_engine_recvrec_ack(self, len);
		}

		while (br_ssl_engine_current_state(self) & BR_SSL_RECVAPP) {
			size_t len = 0;
			unsigned char* buffer = br_ssl_engine_recvapp_buf(self, &len);

			sv_catpvn(RETVAL, (const char*)buffer, len);
			br_ssl_engine_recvapp_ack(self, len);
		}
	} while (offset < STRLEN_length_of_data);
#line 5044 "lib/Crypt/Bear.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__SSL__Engine_push_send); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__SSL__Engine_push_send)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "self, data, flush= false");
    {
	SV *	RETVAL;
	STRLEN	STRLEN_length_of_data;
	size_t	XSauto_length_of_data;
	Crypt__Bear__SSL__Engine	self;
	unsigned char *	data = (unsigned char *)SvPV(ST(1), STRLEN_length_of_data);
	bool	flush;

	XSauto_length_of_data = STRLEN_length_of_data;

	{
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_find(SvRV(ST(0)), PERL_MAGIC_ext) : NULL;
	if (magic && magic->mg_virtual)
		self = (Crypt__Bear__SSL__Engine)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::SSL::Engine object is lacking magic");
	}
;

	if (items < 3)
	    flush = false;
	else {
	    flush = (bool)SvTRUE(ST(2))
;
	}
#line 2044 "lib/Crypt/Bear.xs"
	RETVAL = newSVpvn("", 0);
	size_t offset = 0;

	do {
		while (br_ssl_engine_current_state(self) & BR_SSL_SENDREC) {
			size_t len = 0;
			unsigned char* buffer = br_ssl_engine_sendrec_buf(self, &len);

			sv_catpvn(RETVAL, (const char*)buffer, len);
			br_ssl_engine_sendrec_ack(self, len);
		}

		if (br_ssl_engine_current_state(self) == BR_SSL_CLOSED)
			Perl_croak(aTHX_ "Connection is closed");

		size_t len = 0;
		unsigned char* buffer = br_ssl_engine_sendapp_buf(self, &len);

		if (len && STRLEN_length_of_data) {
			size_t available = STRLEN_length_of_data - offset;

			if (len > available)
				len = available;

			memcpy(buffer, data + offset, len);
			offset += len;
			br_ssl_engine_sendapp_ack(self, len);
		}
	} while (offset < STRLEN_length_of_data);

	if (flush)
		br_ssl_engine_flush(self, false);

	while (br_ssl_engine_current_state(self) & BR_SSL_SENDREC) {
		size_t len = 0;
		unsigned char* buffer = br_ssl_engine_sendrec_buf(self, &len);

		sv_catpvn(RETVAL, (const char*)buffer, len);
		br_ssl_engine_sendrec_ack(self, len);
	}
#line 5124 "lib/Crypt/Bear.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__SSL__Engine_pull_send); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__SSL__Engine_pull_send)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "self, force= false");
    {
	SV *	RETVAL;
	Crypt__Bear__SSL__Engine	self;
	bool	force;

	{
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_find(SvRV(ST(0)), PERL_MAGIC_ext) : NULL;
	if (magic && magic->mg_virtual)
		self = (Crypt__Bear__SSL__Engine)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::SSL::Engine object is lacking magic");
	}
;

	if (items < 2)
	    force = false;
	else {
	    force = (bool)SvTRUE(ST(1))
;
	}
#line 2089 "lib/Crypt/Bear.xs"
	RETVAL = newSVpvn("", 0);

	br_ssl_engine_flush(self, force);

	while (br_ssl_engine_current_state(self) & BR_SSL_SENDREC) {
		size_t len = 0;
		unsigned char* buffer = br_ssl_engine_sendrec_buf(self, &len);

		sv_catpvn(RETVAL, (const char*)buffer, len);
		br_ssl_engine_sendrec_ack(self, len);
	}
#line 5170 "lib/Crypt/Bear.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__SSL__Engine_close); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__SSL__Engine_close)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Crypt__Bear__SSL__Engine	self;

	{
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_find(SvRV(ST(0)), PERL_MAGIC_ext) : NULL;
	if (magic && magic->mg_virtual)
		self = (Crypt__Bear__SSL__Engine)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::SSL::Engine object is lacking magic");
	}
;

	br_ssl_engine_close(self);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__Bear__SSL__Client_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__SSL__Client_new)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "class, anchors");
    {
	Crypt__Bear__SSL__Client	RETVAL;
	Crypt__Bear__X509__TrustAnchors	anchors;

	{
	%:ifdef mg_findext
	MAGIC* magic = SvROK(ST(1)) && SvMAGICAL(SvRV(ST(1))) ? mg_findext(SvRV(ST(1)), PERL_MAGIC_ext, &Crypt__Bear__X509__TrustAnchors_magic) : NULL;
	%:else
	MAGIC* magic = SvROK(ST(1)) && SvMAGICAL(SvRV(ST(1))) ? mg_find(SvRV(ST(1)), PERL_MAGIC_ext) : NULL;
	%:endif
	if (magic)
		anchors = (Crypt__Bear__X509__TrustAnchors)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::X509::TrustAnchors object is lacking magic");
	}
;
#line 2113 "lib/Crypt/Bear.xs"
	RETVAL = safemalloc(sizeof *RETVAL);
	trust_anchors_copy(&RETVAL->trust_anchors, anchors);
	br_ssl_client_init_full(&RETVAL->context, &RETVAL->minimal, RETVAL->trust_anchors.array, RETVAL->trust_anchors.used);
	br_ssl_engine_set_buffer(&RETVAL->context.eng, RETVAL->buffer, sizeof RETVAL->buffer, true);
	private_certificate_init(&RETVAL->private);
#line 5230 "lib/Crypt/Bear.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    {
	    MAGIC* magic = sv_magicext(newSVrv(RETVALSV, "Crypt::Bear::SSL::Client"), NULL, PERL_MAGIC_ext, &Crypt__Bear__SSL__Client_magic, (const char*)RETVAL, 0);
	    magic->mg_flags |= MGf_COPY|MGf_DUP;
	    }
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__SSL__Client_reset); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__SSL__Client_reset)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "self, server_name, resume_session= false");
    {
	bool	RETVAL;
	Crypt__Bear__SSL__Client	self;
	SV *	server_name = ST(1)
;
	bool	resume_session;

	{
	%:ifdef mg_findext
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_findext(SvRV(ST(0)), PERL_MAGIC_ext, &Crypt__Bear__SSL__Client_magic) : NULL;
	%:else
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_find(SvRV(ST(0)), PERL_MAGIC_ext) : NULL;
	%:endif
	if (magic)
		self = (Crypt__Bear__SSL__Client)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::SSL::Client object is lacking magic");
	}
;

	if (items < 3)
	    resume_session = false;
	else {
	    resume_session = (bool)SvTRUE(ST(2))
;
	}
#line 2123 "lib/Crypt/Bear.xs"
	if (SvOK(server_name))
		RETVAL = br_ssl_client_reset(&self->context, SvPV_nolen(server_name), resume_session);
	else
		RETVAL = br_ssl_client_reset(&self->context, NULL, resume_session);
#line 5282 "lib/Crypt/Bear.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__SSL__Client_set_client_certificate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__SSL__Client_set_client_certificate)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, priv_cert");
    {
	Crypt__Bear__SSL__Client	self;
	Crypt__Bear__SSL__PrivateCertificate	priv_cert;

	{
	%:ifdef mg_findext
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_findext(SvRV(ST(0)), PERL_MAGIC_ext, &Crypt__Bear__SSL__Client_magic) : NULL;
	%:else
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_find(SvRV(ST(0)), PERL_MAGIC_ext) : NULL;
	%:endif
	if (magic)
		self = (Crypt__Bear__SSL__Client)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::SSL::Client object is lacking magic");
	}
;

	{
	%:ifdef mg_findext
	MAGIC* magic = SvROK(ST(1)) && SvMAGICAL(SvRV(ST(1))) ? mg_findext(SvRV(ST(1)), PERL_MAGIC_ext, &Crypt__Bear__SSL__PrivateCertificate_magic) : NULL;
	%:else
	MAGIC* magic = SvROK(ST(1)) && SvMAGICAL(SvRV(ST(1))) ? mg_find(SvRV(ST(1)), PERL_MAGIC_ext) : NULL;
	%:endif
	if (magic)
		priv_cert = (Crypt__Bear__SSL__PrivateCertificate)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::SSL::PrivateCertificate object is lacking magic");
	}
;
#line 2133 "lib/Crypt/Bear.xs"
	private_certificate_copy(&self->private, priv_cert);

	if (priv_cert->key.key_type == BR_KEYTYPE_RSA) {
		br_ssl_client_set_single_rsa(&self->context, self->private.chain.array, self->private.chain.used, &self->private.key.rsa, rsa_pkcs1_sign);
	} else if (priv_cert->key.key_type == BR_KEYTYPE_EC) {
		br_ssl_client_set_single_ec(&self->context, self->private.chain.array, self->private.chain.used, &self->private.key.ec, self->private.usage, priv_cert->chain.signer_key_type, ec_default, ec_sign_default);
	} else {
		Perl_croak(aTHX_ "Invalid private key");
	}
#line 5334 "lib/Crypt/Bear.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__Bear__SSL__Client_forget_session); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__SSL__Client_forget_session)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Crypt__Bear__SSL__Client	self;

	{
	%:ifdef mg_findext
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_findext(SvRV(ST(0)), PERL_MAGIC_ext, &Crypt__Bear__SSL__Client_magic) : NULL;
	%:else
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_find(SvRV(ST(0)), PERL_MAGIC_ext) : NULL;
	%:endif
	if (magic)
		self = (Crypt__Bear__SSL__Client)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::SSL::Client object is lacking magic");
	}
;
#line 2145 "lib/Crypt/Bear.xs"
	br_ssl_client_forget_session(&self->context);
#line 5363 "lib/Crypt/Bear.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Crypt__Bear__SSL__Server_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__SSL__Server_new)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "class, priv_cert");
    {
	Crypt__Bear__SSL__Server	RETVAL;
	Crypt__Bear__SSL__PrivateCertificate	priv_cert;

	{
	%:ifdef mg_findext
	MAGIC* magic = SvROK(ST(1)) && SvMAGICAL(SvRV(ST(1))) ? mg_findext(SvRV(ST(1)), PERL_MAGIC_ext, &Crypt__Bear__SSL__PrivateCertificate_magic) : NULL;
	%:else
	MAGIC* magic = SvROK(ST(1)) && SvMAGICAL(SvRV(ST(1))) ? mg_find(SvRV(ST(1)), PERL_MAGIC_ext) : NULL;
	%:endif
	if (magic)
		priv_cert = (Crypt__Bear__SSL__PrivateCertificate)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::SSL::PrivateCertificate object is lacking magic");
	}
;
#line 2154 "lib/Crypt/Bear.xs"
	RETVAL = safemalloc(sizeof *RETVAL);
	private_certificate_copy(&RETVAL->private, priv_cert);

	if (priv_cert->key.key_type == BR_KEYTYPE_RSA) {
		br_ssl_server_init_full_rsa(&RETVAL->context, RETVAL->private.chain.array, RETVAL->private.chain.used, &RETVAL->private.key.rsa);
	} else if (priv_cert->key.key_type == BR_KEYTYPE_EC) {
		br_ssl_server_init_full_ec(&RETVAL->context, RETVAL->private.chain.array, RETVAL->private.chain.used, priv_cert->chain.signer_key_type, &RETVAL->private.key.ec);
	} else {
		Safefree(RETVAL);
		Perl_croak(aTHX_ "Invalid private key");
	}
	br_ssl_engine_set_buffer(&RETVAL->context.eng, RETVAL->buffer, BR_SSL_BUFSIZE_BIDI, true);

	unsigned error = br_ssl_engine_last_error(&RETVAL->context.eng);
	if (error) {
		Safefree(RETVAL);
		Perl_croak(aTHX_ "Could not instantiate server: %s", lookup_error(error));
	}
#line 5410 "lib/Crypt/Bear.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    {
	    MAGIC* magic = sv_magicext(newSVrv(RETVALSV, "Crypt::Bear::SSL::Server"), NULL, PERL_MAGIC_ext, &Crypt__Bear__SSL__Server_magic, (const char*)RETVAL, 0);
	    magic->mg_flags |= MGf_COPY|MGf_DUP;
	    }
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Crypt__Bear__SSL__Server_get_client_suites); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__SSL__Server_get_client_suites)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Crypt__Bear__SSL__Server	self;

	{
	%:ifdef mg_findext
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_findext(SvRV(ST(0)), PERL_MAGIC_ext, &Crypt__Bear__SSL__Server_magic) : NULL;
	%:else
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_find(SvRV(ST(0)), PERL_MAGIC_ext) : NULL;
	%:endif
	if (magic)
		self = (Crypt__Bear__SSL__Server)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::SSL::Server object is lacking magic");
	}
;
#line 2177 "lib/Crypt/Bear.xs"
	size_t len;	
	const br_suite_translated* suites = br_ssl_server_get_client_suites(&self->context, &len);
	for (size_t i = 0; i < len; i++) {
		AV* pair = newAV();
		av_push(pair, newSVuv(suites[i][0]));
		av_push(pair, newSVuv(suites[i][1]));
		mXPUSHs(newRV_noinc((SV*)pair));
	}
#line 5457 "lib/Crypt/Bear.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Crypt__Bear__SSL__Server_reset); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Crypt__Bear__SSL__Server_reset)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	bool	RETVAL;
	Crypt__Bear__SSL__Server	self;

	{
	%:ifdef mg_findext
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_findext(SvRV(ST(0)), PERL_MAGIC_ext, &Crypt__Bear__SSL__Server_magic) : NULL;
	%:else
	MAGIC* magic = SvROK(ST(0)) && SvMAGICAL(SvRV(ST(0))) ? mg_find(SvRV(ST(0)), PERL_MAGIC_ext) : NULL;
	%:endif
	if (magic)
		self = (Crypt__Bear__SSL__Server)magic->mg_ptr;
	else
		Perl_croak(aTHX_ "Crypt::Bear::SSL::Server object is lacking magic");
	}
;
#line 2189 "lib/Crypt/Bear.xs"
	RETVAL = br_ssl_server_reset(&self->context);
#line 5488 "lib/Crypt/Bear.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Crypt__Bear); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Crypt__Bear)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Crypt::Bear::get_config", XS_Crypt__Bear_get_config);
        newXS_deffile("Crypt::Bear::Hash::new", XS_Crypt__Bear__Hash_new);
        newXS_deffile("Crypt::Bear::Hash::update", XS_Crypt__Bear__Hash_update);
        newXS_deffile("Crypt::Bear::Hash::out", XS_Crypt__Bear__Hash_out);
        newXS_deffile("Crypt::Bear::Hash::state", XS_Crypt__Bear__Hash_state);
        newXS_deffile("Crypt::Bear::Hash::set_state", XS_Crypt__Bear__Hash_set_state);
        newXS_deffile("Crypt::Bear::Hash::digest", XS_Crypt__Bear__Hash_digest);
        newXS_deffile("Crypt::Bear::Hash::output_size", XS_Crypt__Bear__Hash_output_size);
        newXS_deffile("Crypt::Bear::HMAC::Key::new", XS_Crypt__Bear__HMAC__Key_new);
        newXS_deffile("Crypt::Bear::HMAC::Key::digest", XS_Crypt__Bear__HMAC__Key_digest);
        newXS_deffile("Crypt::Bear::HMAC::new", XS_Crypt__Bear__HMAC_new);
        newXS_deffile("Crypt::Bear::HMAC::size", XS_Crypt__Bear__HMAC_size);
        newXS_deffile("Crypt::Bear::HMAC::update", XS_Crypt__Bear__HMAC_update);
        newXS_deffile("Crypt::Bear::HMAC::out", XS_Crypt__Bear__HMAC_out);
        newXS_deffile("Crypt::Bear::HMAC::digest", XS_Crypt__Bear__HMAC_digest);
        newXS_deffile("Crypt::Bear::HKDF::new", XS_Crypt__Bear__HKDF_new);
        newXS_deffile("Crypt::Bear::HKDF::inject", XS_Crypt__Bear__HKDF_inject);
        newXS_deffile("Crypt::Bear::HKDF::flip", XS_Crypt__Bear__HKDF_flip);
        newXS_deffile("Crypt::Bear::HKDF::produce", XS_Crypt__Bear__HKDF_produce);
#if XSubPPtmpAAAA
        newXS_deffile("Crypt::Bear::Shake::new", XS_Crypt__Bear__Shake_new);
        newXS_deffile("Crypt::Bear::Shake::inject", XS_Crypt__Bear__Shake_inject);
        newXS_deffile("Crypt::Bear::Shake::flip", XS_Crypt__Bear__Shake_flip);
        newXS_deffile("Crypt::Bear::Shake::produce", XS_Crypt__Bear__Shake_produce);
#endif
        newXS_deffile("Crypt::Bear::CBC::Enc::block_size", XS_Crypt__Bear__CBC__Enc_block_size);
        newXS_deffile("Crypt::Bear::CBC::Enc::run", XS_Crypt__Bear__CBC__Enc_run);
        newXS_deffile("Crypt::Bear::CBC::Dec::block_size", XS_Crypt__Bear__CBC__Dec_block_size);
        newXS_deffile("Crypt::Bear::CBC::Dec::run", XS_Crypt__Bear__CBC__Dec_run);
        newXS_deffile("Crypt::Bear::CTR::block_size", XS_Crypt__Bear__CTR_block_size);
        newXS_deffile("Crypt::Bear::CTR::run", XS_Crypt__Bear__CTR_run);
        newXS_deffile("Crypt::Bear::AES_CBC::Enc::new", XS_Crypt__Bear__AES_CBC__Enc_new);
        newXS_deffile("Crypt::Bear::AES_CBC::Dec::new", XS_Crypt__Bear__AES_CBC__Dec_new);
        newXS_deffile("Crypt::Bear::AES_CTR::new", XS_Crypt__Bear__AES_CTR_new);
        newXS_deffile("Crypt::Bear::AES_CTRCBC::new", XS_Crypt__Bear__AES_CTRCBC_new);
        newXS_deffile("Crypt::Bear::AEAD::reset", XS_Crypt__Bear__AEAD_reset);
        newXS_deffile("Crypt::Bear::AEAD::aad_inject", XS_Crypt__Bear__AEAD_aad_inject);
        newXS_deffile("Crypt::Bear::AEAD::flip", XS_Crypt__Bear__AEAD_flip);
        newXS_deffile("Crypt::Bear::AEAD::run", XS_Crypt__Bear__AEAD_run);
        newXS_deffile("Crypt::Bear::AEAD::get_tag", XS_Crypt__Bear__AEAD_get_tag);
        newXS_deffile("Crypt::Bear::AEAD::check_tag", XS_Crypt__Bear__AEAD_check_tag);
        newXS_deffile("Crypt::Bear::GCM::new", XS_Crypt__Bear__GCM_new);
        newXS_deffile("Crypt::Bear::EAX::new", XS_Crypt__Bear__EAX_new);
        newXS_deffile("Crypt::Bear::CCM::new", XS_Crypt__Bear__CCM_new);
        newXS_deffile("Crypt::Bear::PRNG::system_seeder_name", XS_Crypt__Bear__PRNG_system_seeder_name);
        newXS_deffile("Crypt::Bear::PRNG::generate", XS_Crypt__Bear__PRNG_generate);
        newXS_deffile("Crypt::Bear::PRNG::update", XS_Crypt__Bear__PRNG_update);
        newXS_deffile("Crypt::Bear::PRNG::system_seed", XS_Crypt__Bear__PRNG_system_seed);
        newXS_deffile("Crypt::Bear::HMAC::DRBG::new", XS_Crypt__Bear__HMAC__DRBG_new);
        newXS_deffile("Crypt::Bear::HMAC::DRBG::digest", XS_Crypt__Bear__HMAC__DRBG_digest);
        newXS_deffile("Crypt::Bear::AES_CTR::DRBG::new", XS_Crypt__Bear__AES_CTR__DRBG_new);
        newXS_deffile("Crypt::Bear::RSA::generate_keypair", XS_Crypt__Bear__RSA_generate_keypair);
        newXS_deffile("Crypt::Bear::RSA::PublicKey::pkcs1_verify", XS_Crypt__Bear__RSA__PublicKey_pkcs1_verify);
        newXS_deffile("Crypt::Bear::RSA::PublicKey::oaep_encrypt", XS_Crypt__Bear__RSA__PublicKey_oaep_encrypt);
        newXS_deffile("Crypt::Bear::RSA::PrivateKey::pkcs1_sign", XS_Crypt__Bear__RSA__PrivateKey_pkcs1_sign);
        newXS_deffile("Crypt::Bear::RSA::PrivateKey::oaep_decrypt", XS_Crypt__Bear__RSA__PrivateKey_oaep_decrypt);
        newXS_deffile("Crypt::Bear::EC::supported_curves", XS_Crypt__Bear__EC_supported_curves);
        newXS_deffile("Crypt::Bear::EC::PublicKey::new", XS_Crypt__Bear__EC__PublicKey_new);
        newXS_deffile("Crypt::Bear::EC::PublicKey::curve", XS_Crypt__Bear__EC__PublicKey_curve);
        newXS_deffile("Crypt::Bear::EC::PublicKey::ecdsa_verify", XS_Crypt__Bear__EC__PublicKey_ecdsa_verify);
        newXS_deffile("Crypt::Bear::EC::PrivateKey::new", XS_Crypt__Bear__EC__PrivateKey_new);
        newXS_deffile("Crypt::Bear::EC::PrivateKey::curve", XS_Crypt__Bear__EC__PrivateKey_curve);
        newXS_deffile("Crypt::Bear::EC::PrivateKey::generate", XS_Crypt__Bear__EC__PrivateKey_generate);
        newXS_deffile("Crypt::Bear::EC::PrivateKey::public_key", XS_Crypt__Bear__EC__PrivateKey_public_key);
        newXS_deffile("Crypt::Bear::EC::PrivateKey::ecdsa_sign", XS_Crypt__Bear__EC__PrivateKey_ecdsa_sign);
        newXS_deffile("Crypt::Bear::EC::PrivateKey::ecdh_key_exchange", XS_Crypt__Bear__EC__PrivateKey_ecdh_key_exchange);
        newXS_deffile("Crypt::Bear::PEM::pem_encode", XS_Crypt__Bear__PEM_pem_encode);
        newXS_deffile("Crypt::Bear::PEM::pem_decode", XS_Crypt__Bear__PEM_pem_decode);
        newXS_deffile("Crypt::Bear::PEM::Decoder::new", XS_Crypt__Bear__PEM__Decoder_new);
        newXS_deffile("Crypt::Bear::PEM::Decoder::push", XS_Crypt__Bear__PEM__Decoder_push);
        newXS_deffile("Crypt::Bear::PEM::Decoder::entry_in_progress", XS_Crypt__Bear__PEM__Decoder_entry_in_progress);
        newXS_deffile("Crypt::Bear::X509::Certificate::new", XS_Crypt__Bear__X509__Certificate_new);
        newXS_deffile("Crypt::Bear::X509::Certificate::dn", XS_Crypt__Bear__X509__Certificate_dn);
        newXS_deffile("Crypt::Bear::X509::Certificate::public_key", XS_Crypt__Bear__X509__Certificate_public_key);
        newXS_deffile("Crypt::Bear::X509::Certificate::is_ca", XS_Crypt__Bear__X509__Certificate_is_ca);
        newXS_deffile("Crypt::Bear::X509::Certificate::signer_key_type", XS_Crypt__Bear__X509__Certificate_signer_key_type);
        newXS_deffile("Crypt::Bear::X509::PrivateKey::new", XS_Crypt__Bear__X509__PrivateKey_new);
        newXS_deffile("Crypt::Bear::X509::PrivateKey::unpack", XS_Crypt__Bear__X509__PrivateKey_unpack);
        newXS_deffile("Crypt::Bear::X509::PrivateKey::type", XS_Crypt__Bear__X509__PrivateKey_type);
        newXS_deffile("Crypt::Bear::X509::TrustAnchors::new", XS_Crypt__Bear__X509__TrustAnchors_new);
        newXS_deffile("Crypt::Bear::X509::TrustAnchors::add", XS_Crypt__Bear__X509__TrustAnchors_add);
        newXS_deffile("Crypt::Bear::X509::TrustAnchors::merge", XS_Crypt__Bear__X509__TrustAnchors_merge);
        newXS_deffile("Crypt::Bear::X509::TrustAnchors::names", XS_Crypt__Bear__X509__TrustAnchors_names);
        newXS_deffile("Crypt::Bear::X509::TrustAnchors::count", XS_Crypt__Bear__X509__TrustAnchors_count);
        newXS_deffile("Crypt::Bear::X509::Validator::start_chain", XS_Crypt__Bear__X509__Validator_start_chain);
        newXS_deffile("Crypt::Bear::X509::Validator::start_certificate", XS_Crypt__Bear__X509__Validator_start_certificate);
        newXS_deffile("Crypt::Bear::X509::Validator::append", XS_Crypt__Bear__X509__Validator_append);
        newXS_deffile("Crypt::Bear::X509::Validator::end_certificate", XS_Crypt__Bear__X509__Validator_end_certificate);
        newXS_deffile("Crypt::Bear::X509::Validator::end_chain", XS_Crypt__Bear__X509__Validator_end_chain);
        newXS_deffile("Crypt::Bear::X509::Validator::get_pkey", XS_Crypt__Bear__X509__Validator_get_pkey);
        newXS_deffile("Crypt::Bear::X509::Validator::Minimal::new", XS_Crypt__Bear__X509__Validator__Minimal_new);
#if XSubPPtmpAAAB
        newXS_deffile("Crypt::Bear::X509::Validator::Minimal::set_time", XS_Crypt__Bear__X509__Validator__Minimal_set_time);
        newXS_deffile("Crypt::Bear::X509::Validator::Minimal::set_minrsa", XS_Crypt__Bear__X509__Validator__Minimal_set_minrsa);
#endif
        newXS_deffile("Crypt::Bear::X509::Certificate::Chain::new", XS_Crypt__Bear__X509__Certificate__Chain_new);
        newXS_deffile("Crypt::Bear::X509::Certificate::Chain::add", XS_Crypt__Bear__X509__Certificate__Chain_add);
        newXS_deffile("Crypt::Bear::X509::Certificate::Chain::count", XS_Crypt__Bear__X509__Certificate__Chain_count);
        newXS_deffile("Crypt::Bear::SSL::PrivateCertificate::new", XS_Crypt__Bear__SSL__PrivateCertificate_new);
        newXS_deffile("Crypt::Bear::SSL::PrivateCertificate::chain", XS_Crypt__Bear__SSL__PrivateCertificate_chain);
        newXS_deffile("Crypt::Bear::SSL::PrivateCertificate::key", XS_Crypt__Bear__SSL__PrivateCertificate_key);
        newXS_deffile("Crypt::Bear::SSL::Engine::get_server_name", XS_Crypt__Bear__SSL__Engine_get_server_name);
        newXS_deffile("Crypt::Bear::SSL::Engine::get_version", XS_Crypt__Bear__SSL__Engine_get_version);
        newXS_deffile("Crypt::Bear::SSL::Engine::set_versions", XS_Crypt__Bear__SSL__Engine_set_versions);
        newXS_deffile("Crypt::Bear::SSL::Engine::get_ecdhe_curve", XS_Crypt__Bear__SSL__Engine_get_ecdhe_curve);
        newXS_deffile("Crypt::Bear::SSL::Engine::last_error", XS_Crypt__Bear__SSL__Engine_last_error);
        newXS_deffile("Crypt::Bear::SSL::Engine::inject_entropy", XS_Crypt__Bear__SSL__Engine_inject_entropy);
        newXS_deffile("Crypt::Bear::SSL::Engine::get_session_parameters", XS_Crypt__Bear__SSL__Engine_get_session_parameters);
        newXS_deffile("Crypt::Bear::SSL::Engine::set_session_parameters", XS_Crypt__Bear__SSL__Engine_set_session_parameters);
        newXS_deffile("Crypt::Bear::SSL::Engine::is_closed", XS_Crypt__Bear__SSL__Engine_is_closed);
        newXS_deffile("Crypt::Bear::SSL::Engine::send_ready", XS_Crypt__Bear__SSL__Engine_send_ready);
        newXS_deffile("Crypt::Bear::SSL::Engine::push_received", XS_Crypt__Bear__SSL__Engine_push_received);
        newXS_deffile("Crypt::Bear::SSL::Engine::push_send", XS_Crypt__Bear__SSL__Engine_push_send);
        newXS_deffile("Crypt::Bear::SSL::Engine::pull_send", XS_Crypt__Bear__SSL__Engine_pull_send);
        newXS_deffile("Crypt::Bear::SSL::Engine::close", XS_Crypt__Bear__SSL__Engine_close);
        newXS_deffile("Crypt::Bear::SSL::Client::new", XS_Crypt__Bear__SSL__Client_new);
        newXS_deffile("Crypt::Bear::SSL::Client::reset", XS_Crypt__Bear__SSL__Client_reset);
        newXS_deffile("Crypt::Bear::SSL::Client::set_client_certificate", XS_Crypt__Bear__SSL__Client_set_client_certificate);
        newXS_deffile("Crypt::Bear::SSL::Client::forget_session", XS_Crypt__Bear__SSL__Client_forget_session);
        newXS_deffile("Crypt::Bear::SSL::Server::new", XS_Crypt__Bear__SSL__Server_new);
        newXS_deffile("Crypt::Bear::SSL::Server::get_client_suites", XS_Crypt__Bear__SSL__Server_get_client_suites);
        newXS_deffile("Crypt::Bear::SSL::Server::reset", XS_Crypt__Bear__SSL__Server_reset);

    /* Initialisation Section */

#if XSubPPtmpAAAA
#endif
#line 1210 "lib/Crypt/Bear.xs"
	push_isa(Crypt::Bear::AES_CBC::Enc, Crypt::Bear::CBC::Enc);
	aes_cbc_enc = br_aes_x86ni_cbcenc_get_vtable();
	if (!aes_cbc_enc)
		aes_cbc_enc = &br_aes_ct_cbcenc_vtable;

#line 1225 "lib/Crypt/Bear.xs"
	push_isa(Crypt::Bear::AES_CBC::Dec, Crypt::Bear::CBC::Dec);
	aes_cbc_dec = br_aes_x86ni_cbcdec_get_vtable();
	if (!aes_cbc_dec)
#if IVSIZE == 8
		aes_cbc_dec = &br_aes_ct64_cbcdec_vtable;
#else
		aes_cbc_dec = &br_aes_ct_cbcdec_vtable;
#endif

#line 1244 "lib/Crypt/Bear.xs"
	push_isa(Crypt::Bear::AES_CTR, Crypt::Bear::CTR);
	aes_ctr = br_aes_x86ni_ctr_get_vtable();
	if (!aes_ctr)
#if IVSIZE == 8
		aes_ctr = &br_aes_ct64_ctr_vtable;
#else
		aes_ctr = &br_aes_ct_ctr_vtable;
#endif

#line 1265 "lib/Crypt/Bear.xs"
	push_isa(Crypt::Bear::AES_CTRCBC, Crypt::Bear::CTRCBC);
	aes_ctrcbc = br_aes_x86ni_ctrcbc_get_vtable();
	if (!aes_ctrcbc)
		aes_ctrcbc = &br_aes_ct_ctrcbc_vtable;

#line 1314 "lib/Crypt/Bear.xs"
	push_isa(Crypt::Bear::GCM, Crypt::Bear::AEAD);
	ghash_impl = br_ghash_pclmul_get();
	if (!ghash_impl)
#if IVSIZE == 8
		ghash_impl = &br_ghash_ctmul64;
#else
		ghash_impl = &br_ghash_ctmul;
#endif

#line 1334 "lib/Crypt/Bear.xs"
	push_isa(Crypt::Bear::EAX, Crypt::Bear::AEAD);

#line 1346 "lib/Crypt/Bear.xs"
	push_isa(Crypt::Bear::CCM, Crypt::Bear::AEAD);

#line 1358 "lib/Crypt/Bear.xs"
	system_seeder = br_prng_seeder_system(&system_seeder_name);

#line 1380 "lib/Crypt/Bear.xs"
	push_isa(Crypt::Bear::HMAC::DRBG, Crypt::Bear::PRNG);

#line 1394 "lib/Crypt/Bear.xs"
	push_isa(Crypt::Bear::AES_CTR::DRBG, Crypt::Bear::PRNG);

#line 1407 "lib/Crypt/Bear.xs"
	rsa_keygen = br_rsa_keygen_get_default();

#line 1428 "lib/Crypt/Bear.xs"
	rsa_pkcs1_verify = br_rsa_pkcs1_vrfy_get_default();
	rsa_oaep_encrypt = br_rsa_oaep_encrypt_get_default();

#line 1455 "lib/Crypt/Bear.xs"
	rsa_pkcs1_sign = br_rsa_pkcs1_sign_get_default();
	rsa_oaep_decrypt = br_rsa_oaep_decrypt_get_default();

#line 1484 "lib/Crypt/Bear.xs"
	ec_default = br_ec_get_default();
	ec_sign_default = br_ecdsa_sign_asn1_get_default();
	ec_verify_default = br_ecdsa_vrfy_asn1_get_default();

#line 1882 "lib/Crypt/Bear.xs"
	push_isa(Crypt::Bear::X509::Validator::Minimal, Crypt::Bear::X509::Validator);

#if XSubPPtmpAAAB
#endif
#line 1901 "lib/Crypt/Bear.xs"
	push_isa(Crypt::Bear::X509::Validator::KnownKey, Crypt::Bear::X509::Validator);

#line 2109 "lib/Crypt/Bear.xs"
	push_isa(Crypt::Bear::SSL::Client, Crypt::Bear::SSL::Engine);

#line 2150 "lib/Crypt/Bear.xs"
	push_isa(Crypt::Bear::SSL::Server, Crypt::Bear::SSL::Engine);

#line 5736 "lib/Crypt/Bear.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
